define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), lazyload = require('lazyload'), com = require('com');
    // 模块加载时执行
    exports.init = init;
    var M = {
        'getAllStrategy' : function(start) {
            var strUrl = lib.gameUrl + 'strategy/getAllStrategyApp';
            lib.postCross(strUrl, function(objResult) {
                if (objResult.result == 1) {
                    V.showAllStrategy(objResult);
                    lib.handleLoadPageReady();
                } else {
                    lib.showTip(objResult.msg);
                }
            }, {
                'noLoading' : true,
                'cache'     : true
            });
        },
        'formatList'     : function(arrDataList) {
            if (!arrDataList) {
                return;
            }
            var arrList = $.extend(true, [], arrDataList);
            // 排序
            arrList.sort(function(objA, objB) {
                var strPinyinA = objA.pinyin;
                var strPinyinB = objB.pinyin;
                if (strPinyinA && strPinyinB) {
                    strPinyinA = strPinyinA.toLowerCase();
                    strPinyinB = strPinyinB.toLowerCase();
                    return strPinyinA.localeCompare(strPinyinB);
                } else {
                    return 0;
                }
            });
            // 分组
            var objData = {};
            for (var i = 0, len = arrList.length; i < len; i++) {
                var obj = arrList[i];
                // 设置游戏类型
                var strType = obj.type;
                switch (strType) {
                    case 'hot':
                        obj.iconType = 'icon_hot';
                        break;
                    default:
                        obj.iconType = '';
                        break;
                }
                // 首字母
                var strPinyin = obj.pinyin;
                if (!strPinyin) {
                    console.log('response data format error: missing "pinyin"');
                    break;
                }
                var strAlphabet = strPinyin.slice(0, 1).toUpperCase();
                if (!objData[strAlphabet]) {
                    objData[strAlphabet] = [obj];
                } else {
                    objData[strAlphabet].push(obj);
                }
            }
            // 组合分组数据
            arrList = [];
            for (var k in objData) {
                arrList.push({
                    'alphabet' : k,
                    'gameList' : lib.template2(objData[k], '#gameinfo_template')
                });
            }
            return arrList;
        }
    };
    var V = {
        'showAllStrategy' : function(objResult) {
            var $apps = $('#all_apps');
            var arrList = M.formatList(objResult.list);
            var $html = $(lib.template2(arrList, '#gamelist_template'));
            $('#gamelist_wrap').html($html);
            // 绑定延迟加载图片事件
            if ($html.length) {
                $html.find('img[data-original]').lazyload();
            }
            $('#spinner_list').hide();
        }
    };
    var C = {
        'init' : function() {
            com.bindShowAppEvent('li[redirect]');
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        M.getAllStrategy();
        lib.bindScrollEvent();
    }
});
