define(function(require, exports, module) {
    var $ = require('jquery'), lib = require('lib');
    exports.init = init;
    // 页面配置
    var objConfigs = {
        'title' : '',
        'pages' : [
            {
                'page' : 'url',
                'path' : '',
                'name' : '主页'
            },
            {
                'page' : 'path',
                'path' : 'user-favorite',
                'name' : '游戏收藏'
            }
        ]
    };
    var gameId;
    var M = {
        'getContent' : function(id, path) {
            var strUrl = '';
            if (id === 'url') {
                var isUrl = /^(http|https):\/\//.test(path);
                if (!isUrl) {
                    strUrl = './' + path.replace('-', '/') + '.html';
                } else {
                    strUrl = path;
                }
                var $iframe = $('<iframe frameBorder="0" width="100%"></iframe>');
                $iframe.attr('src', strUrl);
                // 设置高度
                var $subpage = $('#subpage');
                var height = window.innerHeight - $subpage.offset().top;
                $iframe.height(height);
                $('#' + id).append($iframe);
            } else {
                strUrl = './' + path.replace('-', '/') + '.html';
                $.get(strUrl, function(strHtml) {
                    $('#' + id).append(strHtml);
                    $('#' + id).find('.wrapper').css('margin', '0');
                });
            }
        }
    };
    var C = {
        'init'        : function() {
            $('#_tabs').off(gc.click, 'li').on(gc.click, 'li', function() {
                var $this = $(this);
                var id = $this.attr('id').substr(4);
                var path = $this.attr('rel');
                if (!$this.attr('isInit')) {
                    $this.attr('isInit', 'true');
                    M.getContent(id, path);
                } else {
                    //页面要重新init一下，不然滚动条下拉时回调到上个页面的事件
                    C.initTabPage(id);
                }
                $('#subpage>div').hide();
                $('#' + id).show();
                lib.setParam('tab', id, true);
                $('#_tabs li').removeClass('on');
                $this.addClass('on');
            });
        },
        'initTabPage' : function(strId) {
            seajs.use(strId.replace('-', '/js/') + '.js', function(objPage) {
                objPage && objPage.init();
            });
        }
    };
    var V = {
        'init'        : function() {
            lib.template2(objConfigs['pages'], '#tab_li_template', '#_tabs');
            lib.template2(objConfigs['pages'], '#div_template', '#subpage');
            var tab = lib.getParam('tab');
            if (tab) {
                $('#_tabs').find('#tab_' + tab).trigger(gc.click);
            } else {
                $('#_tabs li:first').trigger(gc.click);
            }
        },
        'setPageInfo' : function() {
            // 设置页面URL
            var strUrl = localStorage.getItem('strategyUrl');
            if (strUrl) {
                objConfigs.pages[0].path = strUrl;
            }
            // 设置标题
            var title = lib.getParam('title') || objConfigs['title'];
            lib.setTitle(title);
        }
    };
    // 初始化执行一次
    // C.init();
    function init() {
        C.init();
        V.setPageInfo();
        var tmpGameId = lib.getParam('gameId');
        if (gameId != tmpGameId) {
            gameId = tmpGameId;
            V.init();
        } else {
            var strTab = lib.getParam('tab');
            $('#tab_' + strTab).trigger(gc.click);
        }
        lib.handleLoadPageReady();
    }
})