define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), ll = require('lazyload');
    var objCurrentAppInfo = {};
    var M = {
        'addUserNeed'     : function(strAppId) {
            var strUrl = lib.gameUrl + 'strategy/addUserNeed';
            var objData = {};
            objData.gameId = strAppId;
            objData.adapterId = window.device && window.device.uuid;
            lib.postCross(strUrl, objData, function(objResult) {
                if (objResult.data) {
                    lib.showTip('已经收到啦！');
                } else {
                    lib.showTip('收到！');
                }
            }, {
                'noLoading' : true
            });
        },
        'cancelUserNeed'  : function(strAppId) {
            var strUrl = lib.gameUrl + 'strategy/cancelUserNeed';
            var objData = {};
            objData.gameId = strAppId;
            objData.adapterId = window.device && window.device.uuid;
            lib.postCross(strUrl, objData, function(objResult) {
                if (objResult.result == 1) {
                    lib.showTip('取消成功！');
                } else {
                    lib.showTip(objResult.msg);
                }
            });
        },
        'isNeeded'        : function(strAppId) {
            var strUrl = lib.gameUrl + 'strategy/isNeeded';
            var objData = {};
            objData.gameId = strAppId;
            objData.adapterId = window.device && window.device.uuid;
            lib.postCross(strUrl, objData, function(objResult) {
                if (objResult.result == 1) {
                    if (objResult.data) {
                        lib.showTip('已经收到啦！');
                    } else {
                        M.addUserNeed(strAppId);
                    }
                } else {
                    lib.showTip(objResult.msg);
                }
            }, {
                'noLoading' : true
            });
        },
        'formatMyAppList' : function(arrList, isHome) {
            if (!arrList) {
                return;
            }
            // 首页截取列表，最多显示两行
            var totalCount = getTotalCount();
            if (isHome) {
                arrList = arrList.splice(0, totalCount);
            }
            // for (var i = 0, li = arrList.length; i < li; i++) {
            // var obj = arrList[i];
            // obj.iconType = !obj.hasStrategy ? 'type_lack' : '';
            // }
            return arrList;
        },
        'isAllFav'        : function() {
            var strAppId = lib.getParam('gameId');
            if (strAppId) {
                return false;
            }
            return true;
        }
    };
    var V = {
        'setFontSize'   : function(strFontSize, isIncrease) {
            if (!strFontSize) {
                return;
            }
            var size = parseInt(strFontSize) || 24;
            // 预置字体大小
            var arrFontSize = [20, 24, 28, 32];
            var index = arrFontSize.indexOf(size);
            if (index === -1) {
                return;
            }
            // pinch/zoom
            if (typeof isIncrease !== 'undefined') {
                var len = arrFontSize.length;
                if (isIncrease) {
                    index = ((index + 1) >= len) ? (len - 1) : (index + 1);
                } else {
                    index = ((index - 1) < 0) ? 0 : (index - 1);
                }
                size = arrFontSize[index];
                localStorage.setItem('fontSize', size);
            }
            $('body').css('font-size', size + 'px');
        },
        'updateAppInfo' : function(isFavorite, $this, callback) {
            if (!window.KalaGameGuide) {
                return;
            }
            // 保存攻略信息
            var strAppInfo = localStorage.getItem('appInfo');
            var objAppInfo = strAppInfo && JSON.parse(strAppInfo);
            console.log('objAppInfo: ' + JSON.stringify(objAppInfo));
            
            var strGameId = V.parseGameId();
            console.log('==================================game id: ' + strGameId);
            if (objAppInfo && (objAppInfo.appId === strGameId)) {
                callback && callback(objAppInfo);
                return;
            }
            objAppInfo = {};
            // 收藏页面更新游戏信息
            if (isFavorite) {
                var $ul = $this.closest('ul');
                // 保存游戏信息
                objAppInfo.url = $ul.attr('rel');
                objAppInfo.name = $ul.attr('appName');
                objAppInfo.icon = $ul.attr('icon');
                objAppInfo.appId = $ul.attr('appId');
                objAppInfo.packageName = $ul.attr('packageName');
            }
            
            
            callback && callback(objAppInfo);
        },
        'parseGameId'   : function() {
            var strPath = lib.getRelativePath();
            var idx = strPath.indexOf('/');
            var strGameId = lib.getParam('gameId');
            return strGameId ? strGameId : strPath.substring(0, idx);
        },
        'filterPage'    : function(strId) {
            var strContent = $('#page_template').val();
            var arrMatched = strContent.match(/<!--([\s\S]+)-->/);
            var $content = $(arrMatched[1]);
            return $content.filter(strId);
        }
    };
    var C = {
        'bindShowAppEvent'          : function(strSelector) {
            $('body').off(gc.click, strSelector).on(gc.click, strSelector, function() {
                var $this = $(this);
                var strUrl = $this.attr('rel');
                var strName = $this.attr('appName');
                var strAppId = $this.attr('appId');
                var hasStrategy = $this.attr('hasStrategy');
                var strPackageName = $this.attr('packageName');
                console.log('=================================data-hover: ' + $this.attr('data-hover'));
                console.log('=================================url: ' + strUrl);
                if (strUrl) {
                    console.log('============================hasStrategy: ' + hasStrategy);
                    if (window.KalaGameGuide) {
                        if (hasStrategy === 'false') {
                            lib.confirm('如果您需要请点击「我要」，我们会优先发布我要人数多的攻略哦\n=。= 小编在12小时努力编写中~', function(index) {
                                if (index !== 1) {
                                    return;
                                }
                                M.addUserNeed(strAppId);
                            }, '', '我要,取消');
                        } else {
                            if (KalaGameGuide.openGameTabActivity) {
                                // 保存游戏信息
                                var objAppInfo = {};
                                objAppInfo.url = strUrl;
                                objAppInfo.name = strName;
                                objAppInfo.icon = $this.find('img').attr('data-original');
                                objAppInfo.appId = strAppId;
                                objAppInfo.packageName = strPackageName;
                                localStorage.setItem('appInfo', JSON.stringify(objAppInfo));
                                KalaGameGuide.openGameTabActivity(strName, strUrl, strAppId, strPackageName, objAppInfo.icon);
                            }
                        }
                    } else {
                        // 保存地址
                        localStorage.setItem('strategyUrl', strUrl);
                        lib.setParam('tab', 'url');
                        lib.setParam('title', strName);
                        lib.setParam('gameId', strAppId);
                        lib.removeParam('tabType');
                        lib.redirect('guide-app_strategy');
                    }
                    if (hasStrategy !== 'false') {
                        // 上报点击应用
                        gc.reportAction(lib.getRealPage(), 'click_app', 0, strName + '|' + lib.getRelativePath(true, strUrl) + '|' + strAppId);
                    }
                }
            });
        },
        'bindShowStrategyEvent'     : function(strSelector, isFavorite) {
            $('body').off(gc.click, strSelector).on(gc.click, strSelector, function() {
                var $this = $(this);
                var strUrl = $this.attr('rel');
                var strTitle = $.trim($this.find('[sTitle]').text());
                var strClass = $this.find('span').attr('class') || '';
                console.log('=================================data-hover: ' + $this.attr('data-hover'));
                console.log('=================================url: ' + strUrl);
                if (!strUrl) {
                    return;
                }
                // 打开攻略
                if (window.KalaGameGuide) {
                    // 保存攻略信息
                    V.updateAppInfo(isFavorite, $this, function(objAppInfo) {
                        console.log('===========================updated info: ' + JSON.stringify(objAppInfo))
                        if (objAppInfo) {
                            // 添加攻略信息
                            objAppInfo.strategy = [
                                {
                                    'url'   : strUrl,
                                    'title' : strTitle,
                                    'class' : strClass
                                }
                            ];
                            
                            localStorage.setItem('appInfo', JSON.stringify(objAppInfo));
                        }
                        KalaGameGuide.openActivity && KalaGameGuide.openActivity('攻略详情', strUrl, false, strClass);
                    });
                } else {
                    // 区分网页iframe打开和直接打开
                    var strTarget = '_blank';
                    if ((window.self == window.top) && lib.getParam('tab') !== 'user-favorite') {
                        strTarget = '_self';
                    }
                    window.open(strUrl, strTarget);
                }
                // 上报点击攻略
                gc.reportAction(lib.getRealPage(), 'click_strategy', 0, strTitle + '|' + lib.getRelativePath(true, strUrl));
            });
        },
        'bindShowStrategyListEvent' : function(strSelector, strTpl) {
            $('body').off(gc.click, strSelector).on(gc.click, strSelector, function() {
                var $this = $(this);
                var strUrl = $this.attr('rel');
                var strName = $.trim($this.find('[sTitle]').text());
                console.log('=================================data-hover: ' + $this.attr('data-hover'));
                if (strUrl && !$this.hasClass('nocontent')) {
                    if (window.KalaGameGuide && KalaGameGuide.openActivity) {
                        KalaGameGuide.openActivity(strName, strUrl, true);
                    } else {
                        // 区分网页iframe打开和直接打开
                        var strTarget = (window.self == window.top) ? '_self' : '_blank';
                        window.open(strUrl, strTarget);
                    }
                    // 上报点击栏目
                    var strTitle = $.trim($this.find('[sTitle]').text());
                    gc.reportAction(strTpl, 'click_column', 0, strTitle + '|' + lib.getRelativePath(true, strUrl));
                }
            });
        },
        'bindInitPageEvent'         : function() {
            var $body = $('body');
            var $content = null;
            if (!window.KalaGame) {
                var isiFrame = (window.self != window.top);
                if (!isiFrame) {
                    var isMobile = lib.isMobile();
                    if (isMobile) {
                        $content = V.filterPage('#share_mobile');
                    } else {
                        $content = V.filterPage('#share_pc');
                    }
                }
                var $wrap = $('#pageswarp');
                if (lib.getParam('isClientView') || isiFrame) {
                    $wrap.show();
                } else {
                    $wrap.remove();
                    $content.appendTo($body);
                }
            }
            lib.bindScrollEvent();
            // 图片渐现
            $body.find('img[data-original]').lazyload();
        }
    };

    /**
     * 获取首页显示图标数
     */
    function getTotalCount(maxRow) {
        var deviceWidth = window.innerWidth;
        // 显示最多行数
        maxRow = maxRow || 2;
        // 首页单行显示数目
        var count4 = 4, count5 = 5, count6 = 6;
        var totalCount = 0;
        if (deviceWidth < 600) {
            totalCount = count4 * maxRow;
        } else if (deviceWidth >= 600 && deviceWidth < 1024) {
            totalCount = count5 * maxRow;
        } else {
            totalCount = count6 * maxRow;
        }
        return totalCount;
    }

    // 模块加载时执行
    exports.isAllFav = M.isAllFav;
    exports.parseGameId = V.parseGameId;
    exports.setFontSize = V.setFontSize;
    exports.getTotalCount = getTotalCount;
    exports.updateAppInfo = V.updateAppInfo;
    exports.formatMyAppList = M.formatMyAppList;
    exports.bindShowAppEvent = C.bindShowAppEvent;
    exports.bindInitPageEvent = C.bindInitPageEvent;
    exports.bindShowStrategyEvent = C.bindShowStrategyEvent;
    exports.bindShowStrategyListEvent = C.bindShowStrategyListEvent;
});
