define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), lazyload = require('lazyload'), com = require('com');
    // 模块加载时执行
    exports.init = init;
    var M = {
        'getAllStrategy' : function() {
            var strUrl = lib.gameUrl + 'strategy/getAllStrategyApp';
            var objData = {};
            objData.start = 0;
            // 显示4行
            objData.count = com.getTotalCount(4);
            lib.postCross(strUrl, objData, function(objResult) {
                if (objResult.result == 1) {
                    lib.handleLoadPageReady();
                    V.showAllStrategy(objResult);
                } else {
                    lib.showTip(objResult.msg);
                }
            }, {
                'cache'     : true,
                'noLoading' : true
            });
        },
        'formatList'     : function(arrList) {
            if (!arrList) {
                return;
            }
            for (var i = 0, len = arrList.length; i < len; i++) {
                var obj = arrList[i];
                var strType = obj.type;
                // 设置游戏类型
                switch (strType) {
                    case 'hot':
                        obj.iconType = 'icon_hot';
                        break;
                    default:
                        obj.iconType = '';
                        break;
                }
            }
            return arrList;
        }
    };
    var V = {
        'showAllStrategy'   : function(objResult) {
            var arrList = M.formatList(objResult.list);
            if (arrList.length) {
                var $html = $(lib.template2(arrList, '#all_apps_template'));
                $('#all_apps').html($html);
                // 绑定延迟加载图片事件
                $html && $html.find('img').lazyload();
            }
            $('#spinner_list').hide();
        },
        'showMyAppStrategy' : function(objResult) {
            var arrList = objResult ? objResult.list : [];
            var $blkbox = $('#blkbox');
            var $wrapper = $('#gamelistwrap');
            if (arrList.length) {
                arrList = com.formatMyAppList(arrList, true);
                $blkbox.hide();
                var $myApps = $wrapper.find('ul');
                var $html = $(lib.template2(arrList, '#my_apps_template'));
                $myApps.html($html);
                $wrapper.show();
                // 绑定延迟加载图片事件
                $html && $html.find('img').lazyload();
            } else {
                $blkbox.show();
                $wrapper.hide();
            }
            $wrapper.find('.spinner').hide();
        }
    };
    var C = {
        'init' : function() {
            com.bindShowAppEvent('li[redirect]');
            // 测试入口
            if (!window.KalaGameGuide) {
                $('#temp_test').show();
            }
            var strMyApps = localStorage.getItem('myApps');
            var objMyApps = strMyApps && JSON.parse(strMyApps);
            if (objMyApps) {
                V.showMyAppStrategy(objMyApps);
                lib.handleLoadPageReady();
                setTimeout(M.getAllStrategy, 500);
            } else {
                M.getAllStrategy();
            }
            if (window.KalaGameGuide && KalaGameGuide.getMyGame) {
                KalaGameGuide.getMyGame && KalaGameGuide.getMyGame();
            }
        }
    };
    // 初始化执行一次
    // C.init();
    function init() {
        C.init();
        if (!window.KalaGameGuide) {
            $('#blkbox').show();
            $('#gamelistwrap').hide();
            V.showMyAppStrategy();
        } else {
            // 我的游戏攻略回调
            gc.showMyAppStrategy = function(objResult) {
                // 保存我的游戏
                localStorage.setItem('myApps', JSON.stringify(objResult));
                V.showMyAppStrategy(objResult);
                lib.handleLoadPageReady();
            };
        }
        lib.bindScrollEvent();
    }
});
