define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), lazyload = require('lazyload'), com = require('com');
    // 模块加载时执行
    exports.init = init;
    var M = {
        'getStrategyApp' : function(start) {
            var strSearchText = lib.getParam('searchText');
            if (!strSearchText) {
                return;
            }
            var strUrl = lib.gameUrl + 'strategy/searchStrategyAppByName';
            var objData = {};
            objData.start = start || 0;
            objData.count = gc.defaultListCount;
            objData.searchText = strSearchText;
            lib.postCross(strUrl, objData, function(objResult) {
                if (objResult.result == 1) {
                    V.showStrategyApp(objResult);
                    lib.handleLoadPageReady();
                } else {
                    lib.showTip(objResult.msg);
                }
            });
        },
        'formatList'     : function(arrDataList) {
            if (!arrDataList) {
                return;
            }
            return arrDataList;
        }
    };
    var V = {
        'showStrategyApp' : function(objResult) {
            var arrList = M.formatList(objResult.list);
            var $blkbox = $('#blkbox');
            var $result = $('#search_result');
            if (arrList.length) {
                var $html = $(lib.template2(arrList, '#result_template'));
                $blkbox.hide();
                $result.html($html).show();
                // 绑定延迟加载图片事件
                if ($html.length) {
                    $html.find('img[data-original]').lazyload();
                }
            } else {
                $blkbox.show();
                $result.hide();
            }
            $('#spinner').hide();
        }
    };
    var C = {
        'init' : function() {
            com.bindShowAppEvent('li[redirect]');
        }
    };
    // 初始化执行一次
    // C.init();
    function init() {
        C.init();
        M.getStrategyApp();
    }
});
