define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), lazyload = require('lazyload'), com = require('com');
    // 模块加载时执行
    exports.init = init;
    var M = {
        'searchStrategy' : function(start) {
            var strSearchText = lib.getParam('searchText');
            if (!strSearchText) {
                return;
            }
            var strUrl = lib.gameUrl + 'strategy/searchStrategy';
            var objData = {};
            objData.start = start || 0;
            objData.count = gc.defaultListCount;
            objData.gameId = lib.getParam('gameId');
            objData.searchText = strSearchText;
            lib.postCross(strUrl, objData, function(objResult) {
                if (objResult.result == 1) {
                    V.showStrategy(objResult);
                    lib.handleLoadPageReady();
                } else {
                    lib.showTip(objResult.msg);
                }
            });
        },
        'formatList'     : function(arrDataList) {
            if (!arrDataList) {
                return;
            }

            var len = arrDataList.length, obj = null, typeId = null;
            for (var i = 0; i < len; i++) {
                obj = arrDataList[i];
                typeId = parseInt(obj.typeId);
                switch (typeId) {
                    case 53:
                        obj.typeClass = 'icons icons_player';
                        break;
                    case 54:
                        obj.typeClass = 'icons icons_music';
                        break;
                    default :
                        obj.typeClass = '';
                        break;
                }
            }

            return arrDataList;
        }
    };
    var V = {
        'showStrategy' : function(objResult) {
            var arrList = M.formatList(objResult.list);
            var $blkbox = $('#blkbox');
            var $result = $('#search_result');
            if (arrList.length) {
                var $html = $(lib.template2(arrList, '#result_template'));
                $blkbox.hide();
                $result.html($html).show();
                // 绑定延迟加载图片事件
                if ($html.length) {
                    $html.find('img[data-original]').lazyload();
                }
            } else {
                $blkbox.show();
                $result.hide();
            }
            $('#spinner').hide();
        }
    };
    var C = {
        'init' : function() {
            com.bindShowStrategyEvent('li[redirect]');
        }
    };
    // 初始化执行一次
    // C.init();
    function init() {
        C.init();
        M.searchStrategy();
    }
});
