define(function(require, exports, module) {
    var $ = require('jquery'), lib = require('lib'), lazyload = require('lazyload'), com = require('com');
    exports.init = init;
    var M = {
        'getAppInfo'      : function(callback) {
            var strUrl = lib.gameUrl + 'strategy/getStrategyAppInfo';
            var objData = {};
            objData.gameId = com.parseGameId();
            console.log('=========================DO NOT have app info');
            lib.postCross(strUrl, objData, function(objResult) {
            	console.log("getAppInfo:" + JSON.stringify(objResult));
                if (objResult.result == 1) {
                    callback && callback(objResult);
                } else {
                    lib.showTip(objResult.msg);
                }
            }, {
                'cache' : true,
                'noLoading' : false
            });
        },
        'getStrategyInfo' : function() {
        	var data = {};
        	data.url = $("body").attr("rel");
        	data.type = $("body").attr("type");
        	if (data.url) {
        		var parts = data.url.match(/\/strategy\/(\d+)\//);
            	data.appId = parts[1];
        	}
            
            data.title = $("body").attr("strategyTitle");
            data.gameTitle = $("body").attr("appName");

        	return data;
        }
    };
    var V = {
        'updateInfo'        : function(isAdded, callback) {
        	var data = M.getStrategyInfo();
        	
            if (isAdded) {
            	KalaGameGuide.removeFavData(data.appId, data.url);
            } else {
            	KalaGameGuide.setFavData(JSON.stringify(data));
            }
            
            callback && callback();
        },
        'setFavStatus'      : function() {
            var data = M.getStrategyInfo();
        	KalaGameGuide.hasFavData(data.appId, data.url, function(objResult) {
        		console.log(objResult);
        		var $fav = $('#add_fav');
        		if (objResult) {
                    $fav.addClass('added');
        		} else {
        			$fav.removeClass('added');
        		}
        	});
        },
        'filterPage'        : function(strId) {
            var strContent = $('#page_template').val();
            var arrMatched = strContent.match(/<!--([\s\S]+)-->/);
            var $content = $(arrMatched[1]);
            return $content.filter(strId);
        },
        'showNotification'  : function() {
            var net = navigator.network;
            var is2G = net && net.connection && net.connection.type == Connection.CELL_2G;
            var is3G = net && net.connection && net.connection.type == Connection.CELL_3G;
            var is4G = net && net.connection && net.connection.type == Connection.CELL_4G;
            var strNoImageMode = localStorage.getItem('noImageMode');
            if (typeof strNoImageMode != "string") {
                strNoImageMode = '1';
            }
            var isNoImageMode = (strNoImageMode == '1') && (is2G || is3G || is4G);
            var strNotified = localStorage.getItem('hasNotified');
            if (isNoImageMode && !strNotified) {
                lib.confirm('为了节省您的流量，无图模式已开启，可在设置中进行修改', function() {
                    localStorage.setItem('hasNotified', true);
                }, '', '确定');
            }
        },
        'initPage'          : function() {
            var $body = $('body');
            var $content = null;
            var strPageType = 'client';
            if (!window.KalaGame) {
                var isMobile = lib.isMobile();
                if (isMobile) {
                    $content = V.filterPage('#share_mobile');
                    strPageType = 'mobile'
                } else {
                    $content = V.filterPage('#share_pc');
                    strPageType = 'pc';
                }
                var $wrap = $('#pageswarp');
                if (lib.getParam('isClientView')) {
                    $wrap.show();
                } else {
                    $wrap.remove();
                    $content.appendTo($body);
                }
            }
            $('#spinner').hide();
            lib.bindScrollEvent();
            // 设置收藏状态
            if (window.KalaGameGuide) {
                V.setFavStatus();
            }
            // 图片渐现
            $body.find('img[data-original]').lazyload();
            // 上报显示攻略
            var strTitle = $.trim($('span.gi_name, h1.ch_title').text());
            V.initAudioDuration();
            gc.reportAction(lib.getRealPage(), 'show_strategy', 0, strTitle + '|' + strPageType + '|' + lib.getRelativePath());
        },
        'initAudioDuration' : function() {
            $('audio').on('canplaythrough', function() {
                var $this = $(this);
                var $time = $this.parent().find('.audio_time');
                var $play = $this.parent().find('.audio_state');
                var audio = $this[0];
                //android设置不了audio.duration，但可以设置attr('duration')
                var duration = audio.duration || $this.attr('duration');
                
                console.log('canplaythrough triggered~, duration:' + duration);
                $time.html(V.formatDuration(duration));
            }).on('pause ended', function(event) {
            	console.log("event:" + event.type);
            	
                var $play = $(this).parent().find('.audio_state');
            	$play.removeClass('audio_playing');
            });
        },
        'formatDuration'    : function(duration) {
            duration = duration ? parseInt(duration) : 0;
            var strMinutes = '', strSeconds = '';
            var minutes = Math.floor(duration / 60);
            var seconds = duration % 60;
            if (minutes) {
                strMinutes = minutes + '\'';
            }
            strSeconds = seconds + '\'\'';
            return strMinutes + strSeconds;
        }
    };
    var C = {
        'init'                       : function() {
            if (window.KalaGameGuide) {
                V.showNotification();
            }
            lib.initDataHover();
            C.bindAddFavEvent();
            C.bindPlayAudioEvent();
            C.bindShowOriginalImageEvent();
        },
        'bindAddFavEvent'            : function() {
            if (window.KalaGameGuide) {
                $('body').on(gc.click, '#icons_addtofav', function() {
                    var $fav = $('#add_fav');
                    var isAdded = $fav.hasClass('added');
                    V.updateInfo(isAdded, function() {
                        if (isAdded) {
                            $fav.removeClass('added');
                            lib.showTip('取消收藏成功');
                        } else {
                            $fav.addClass('added');
                            lib.showTip('收藏成功');
                        }
                        if (window.KalaGame && KalaGame.sendBroadcast) {
                            KalaGame.sendBroadcast("user-favorite", "init");
                        }
                        // 上报收藏
                        var strTitle = $.trim($('span.gi_name, h1.ch_title').text());
                        gc.reportAction(lib.getRealPage(), 'favorite', 0, strTitle + '|' + lib.getRelativePath() + '|' + (isAdded ? 'cancel' : 'add'));
                    });
                });
                $('body').on(gc.click, '#icons_share', function() {
                    if (KalaGameGuide.showShare) {
			            //保卫萝卜全部炮塔的属性及优势图鉴3 - 炮塔介绍 - 我打 | 游戏攻略最全的APP
                    	var data = M.getStrategyInfo();
                        var strName = '#' + data.gameTitle + '#';
                        var strTitle = data.title;
                        var strContent = strName + strTitle + ': ' + data.url;
                        KalaGameGuide.showShare(strTitle, strContent);
                        // 上报分享
                        gc.reportAction(lib.getRealPage(), 'share', 0, strContent);
                    }
                    return false;
                });
            }
        },
        'bindShowOriginalImageEvent' : function() {
            $('body').on(gc.click, 'img[data-original]', function() {
                var $this = $(this);
                var $content = $('body');
                // 设置当前点击图片的索引
                var index = $content.find('img[data-original]').index($this);
                lib.showOriginalImg($content, index);
                // 阻止事件冒泡
                return false;
            });
        },
        'bindPlayAudioEvent'         : function() {
            $('body').on(gc.click, '.audiobox', function() {
                var $this = $(this);
                var $play = $this.find('.audio_state');
                var audio = $this.find('audio')[0];
                if (!$play.hasClass('audio_playing')) {
                	console.log("audio.play();");
                    $play.addClass('audio_playing');
                    
                    if (window.KalaGameGuide && KalaGameGuide.playAudio) {
                    	KalaGameGuide.playAudio(audio.src);
                    } else {
                    	audio.play();
                    }
                } else {
                    console.log("audio.pause();");
                    $play.removeClass('audio_playing');
                    if (window.KalaGameGuide && KalaGameGuide.pauseAudio) {
                    	KalaGameGuide.pauseAudio(audio.src);
                    } else {
                    	audio.pause();
                    }
                }
                return false;
            });
            
            $('audio').on("click", function(event) {
            	console.log("click event.type:" + event.type);
            	if (window.KalaGameGuide) {
            		return false;
            	}
            });
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        lib.setParam('page', 'strategy_content');
        V.initPage();
        // 修改字体大小回调
        gc.changeFontSize = function(isIncrease) {
            var strSize = parseInt($('body').css('font-size'));
            if (!strSize) {
                return;
            }
            com.setFontSize(strSize, isIncrease);
        }
        lib.handleLoadPageReady();
    }
})