(function() {
    //判断是否在webview环境下
    if (!window.KLPlugin || !KLPlugin.exec) {
        return;
    }
    //初始化参数
    initParam();
    //基础功能
    window.device = window.device || {};
    window.navigator = window.navigator || {};
    navigator.network = navigator.network || {};
    navigator.network.connection = navigator.network.connection || {};
    window.Connection = {
        UNKNOWN  : "unknown",
        ETHERNET : "ethernet",
        WIFI     : "wifi",
        CELL_2G  : "2g",
        CELL_3G  : "3g",
        CELL_4G  : "4g",
        NONE     : "none"
    };
    KLPlugin.succCallback = {};
    KLPlugin.errorCallback = {};
    var requstId = 1;

    function initParam() {
        //file:///android_asset/开头的url需要特殊处理
        if (/file:\/\/\/android_asset\//.test(document.location.href)) {
            var param = prompt("gap://KLCommon/getParam/");
            console.log("gap://KLCommon/getParam/:" + param);
            if (param != null) {
                document.location.href = param;
            }
        }
    }

    //执行调用
    function exec(succCallback, errorCallback, className, func, params) {
        if (params && params.length) {
            params = JSON.stringify(params);
        } else {
            params = null;
        }
        if (succCallback) {
            KLPlugin.succCallback[requstId] = succCallback;
        }
        if (errorCallback) {
            KLPlugin.errorCallback[requstId] = errorCallback;
        }
        if (window.KLPlugin && KLPlugin.exec) {
            KLPlugin.exec(requstId++, className, func, params);
        }
    }

    window.KLCommon = {};
    KLCommon.post = function(url, data, callback, option) {
        exec(callback, callback, "KLCommon", "post", [url, data, option]);
    };
    KLCommon.get = function(url, callback, option) {
        exec(callback, callback, "KLCommon", "get", [url, option]);
    };
    KLCommon.loadImage = function(url, succCallback, errorCallback) {
        exec(succCallback, errorCallback, "KLCommon", "loadImage", [url]);
    }
    /*
     KLCommon.onScroll = function(succCallback) {
     exec(succCallback, null, "KLCommon", "onScroll", []);
     }
     */
    KLCommon.onScrollToBottom = function(succCallback) {
        exec(succCallback, null, "KLCommon", "onScrollToBottom", []);
    }
    //KalaGame
    window.KalaGame = {};
    KalaGame.session = function(uid, token, openId, openToken) {
        exec(null, null, "KalaGame", "session", [uid, token, openId, openToken]);
    };
    KalaGame.onPaySuccess = function(clientParam) {
        exec(null, null, "KalaGame", "onPaySuccess", [clientParam]);
    };
    KalaGame.onPayFail = function(code, msg) {
        exec(null, null, "KalaGame", "onPayFail", [code, msg]);
    };
    KalaGame.onChargeSuccess = function(clientParam) {
        exec(null, null, "KalaGame", "onChargeSuccess", [clientParam]);
    };
    KalaGame.requestTimeout = function() {
        exec(null, null, "KalaGame", "requestTimeout", []);
    };
    KalaGame.loadPageReady = function() {
        exec(null, null, "KalaGame", "loadPageReady", []);
    };
    KalaGame.closeWebview = function() {
        exec(null, null, "KalaGame", "closeWebview", []);
    };
    KalaGame.showTip = function(msg, timeout) {
        exec(null, null, "KalaGame", "showTip", [msg, timeout]);
    };
    KalaGame.showLoading = function(loadingText) {
        loadingText = loadingText || "正在加载中...";
        exec(null, null, "KalaGame", "showLoading", [loadingText]);
    };
    KalaGame.hideLoading = function() {
        exec(null, null, "KalaGame", "hideLoading", []);
    };
    KalaGame.setMediumZoom = function() {
        exec(null, null, "KalaGame", "setMediumZoom", []);
    };
    KalaGame.setFarZoom = function() {
        exec(null, null, "KalaGame", "setFarZoom", []);
    };
    //回调函数gc.getTelNum(tel)
    KalaGame.getTelNum = function() {
        exec(null, null, "KalaGame", "getTelNum", []);
    };
    //sendSms(String reciver, String msg)
    KalaGame.sendSms = function(reciver, msg) {
        exec(null, null, "KalaGame", "sendSms", [reciver, msg]);
    };
    KalaGame.registerSmsReceiver = function() {
        exec(null, null, "KalaGame", "registerSmsReceiver", []);
    };
    KalaGame.checkSmsInbox = function() {
        exec(null, null, "KalaGame", "checkSmsInbox", []);
    };
    KalaGame.openUrl = function(url) {
        exec(null, null, "KalaGame", "openUrl", [url]);
    };
    // create post
    KalaGame.createPost = function(str) {
        exec(null, null, "KalaGame", "createPost", [str]);
    };
    // create reply
    KalaGame.createReply = function(str) {
        exec(null, null, "KalaGame", "createReply", [str]);
    };
    // upload avatar
    KalaGame.uploadAvatar = function(str) {
        exec(null, null, "KalaGame", "uploadAvatar", [str]);
    };
    // get picture
    KalaGame.getPicture = function(onSuccess, onFail, edit) {
        var success = 'successCallback' + (new Date()).getTime();
        var fail = 'errorCallback' + (new Date()).getTime();
        gc[success] = onSuccess;
        gc[fail] = onFail;
        exec(null, null, "KalaGame", "getPicture", [success, fail, edit]);
    };
    KalaGame.logout = function() {
        exec(null, null, "KalaGame", "logout", []);
    };
    /*
     KalaGame.saveConfig = function(pageConfigs) {
     exec(null, null, "KalaGame", "saveConfig", [pageConfigs]);
     };
     */
    KalaGame.setIsBusy = function(flag) {
        exec(null, null, "KalaGame", "setIsBusy", [flag]);
    };
    KalaGame.openCardCharge = function() {
        exec(null, null, "KalaGame", "openCardCharge", []);
    };
    KalaGame.setUserConfigInfo = function(json) {
        exec(null, null, "KalaGame", "setUserConfigInfo", [json]);
    };
    //梦宝谷验证接口
    KalaGame.authorizeToken = function(oauth_token, getUser) {
        exec(null, null, "MbgKalaGame", "authorizeToken", [oauth_token, getUser]);
    };
    //梦宝谷创建订单
    KalaGame.createTransaction = function(transactionId, num) {
        exec(null, null, "MbgKalaGame", "createTransaction", [transactionId, num]);
    };
    //小米登录接口
    KalaGame.miLogin = function(type) {
        exec(null, null, "MiKalaGame", "miLogin", [type]);
    };
    //小米充值接口
    KalaGame.miPay = function(orderId, totalFee) {
        exec(null, null, "MiKalaGame", "miPay", [orderId, totalFee]);
    };
    // 小米充值卡充值接口
    KalaGame.miCardPay = function(orderId, cardInfo) {
        exec(null, null, "MiKalaGame", "miCardPay", [orderId, cardInfo]);
    }
    //小米充值卡页面
    KalaGame.openMiCardCharge = function() {
        exec(null, null, "MiKalaGame", "openMiCardCharge", []);
    };
    // 优视登录接口
    KalaGame.ucLogin = function() {
        exec(null, null, "UCKalaGame", "ucLogin", []);
    }
    // 优视充值接口
    KalaGame.ucPay = function(vouchCode, userId, amount) {
        exec(null, null, "UCKalaGame", "ucPay", [vouchCode, userId, amount]);
    }
    // 当乐登录接口
    KalaGame.djLogin = function() {
        exec(null, null, "DJKalaGame", "djLogin", []);
    }
    // 当乐充值接口
    KalaGame.djPay = function(vouchCode, userId, fee) {
        exec(null, null, "DJKalaGame", "djPay", [vouchCode, userId, fee]);
    }
    // 腾讯第三方授权
    KalaGame.tencentAuthorize = function(action) {
        exec(null, null, "KalaGame", "tencentAuthorize", [action]);
    }
    // 新浪微博第三方授权
    KalaGame.sinaWeiboAuthorize = function(action) {
        exec(null, null, "KalaGame", "sinaWeiboAuthorize", [action]);
    }
    KalaGame.sendBroadcast = function(page, method, param) {
        exec(null, null, "KalaGame", "sendBroadcast", [page, method, param]);
    }
    KalaGame.score = function() {
        exec(null, null, "KalaGame", "score", []);
    }
    //KalaGameUi
    window.KalaGameUi = {};
    // { "callback" : "gc.selectCallback", "title" : "标题", "data" : [{"text" : "选择相册", "name" : "album"}, {"text" : "拍照", "name" : "camer"}] }
    KalaGameUi.showSelectDialog = function(option) {
        var callback = 'callback' + (new Date()).getTime();
        gc[callback] = option['callback'];
        option['callback'] = "gc." + callback;
        exec(null, null, "KalaGameUi", "showSelectDialog", [option]);
    };
    KalaGameUi.setBarTitle = function(title) {
        exec(null, null, "KalaGameUi", "setBarTitle", [title]);
    };
    KalaGameUi.startBigImgActivity = function(json) {
        exec(null, null, "KalaGameUi", "startBigImgActivity", [json]);
    };
    KalaGameUi.setLandscape = function() {
        exec(null, null, "KalaGameUi", "setLandscape", []);
    };
    KalaGameUi.setPortrait = function() {
        exec(null, null, "KalaGameUi", "setPortrait", []);
    };
    KalaGameUi.setSensor = function() {
        exec(null, null, "KalaGameUi", "setSensor", []);
    };
    KalaGameUi.closeRefresh = function() {
        exec(null, null, "KalaGameUi", "closeRefresh", []);
    };
    KalaGameUi.showWebView = function() {
        exec(null, null, "KalaGameUi", "showWebView", []);
    };
    KalaGameUi.openActivity = function(page, param) {
        exec(null, null, "KalaGameGuide", "openNormalActivity", [page, param]);
    };
    KalaGameUi.showInput = function() {
        exec(null, null, "KalaGameUi", "showInput", []);
    };
    KalaGameUi.hideInput = function() {
        exec(null, null, "KalaGameUi", "hideInput", []);
    };
    KalaGameUi.confirm = function(msg, callbackFunc, title, buttonLabels) {
        var callback = 'callback' + (new Date()).getTime();
        gc[callback] = callbackFunc;
        exec(null, null, "KalaGameUi", "confirm", [msg, "gc." + callback, title, buttonLabels]);
    };
    KalaGameUi.openBbsListActivity = function(page, param) {
        exec(null, null, "KalaGameUi", "openBbsListActivity", [page, param]);
    };
    KalaGameUi.openBbsContentActivity = function(page, param) {
        exec(null, null, "KalaGameUi", "openBbsContentActivity", [page, param]);
    };
    KalaGameUi.showReplyBtn = function() {
        exec(null, null, "KalaGameUi", "showReplyBtn", []);
    };
    KalaGameUi.hideReplyBtn = function() {
        exec(null, null, "KalaGameUi", "hideReplyBtn", []);
    };
    KalaGameUi.updateNewMsgCount = function(strCount) {
        exec(null, null, "KalaGameUi", "updateNewMsgCount", [strCount]);
    };
    KalaGameUi.updateBbsOrder = function(nOrder) {
        exec(null, null, "KalaGameUi", "updateBbsOrder", [nOrder]);
    };
    KalaGameUi.setCurrentView = function(nIndex) {
        exec(null, null, "KalaGameUi", "setCurrentView", [nIndex]);
    };
    KalaGameUi.openSendMsgActivity = function(friendId) {
        exec(null, null, "KalaGameUi", "openSendMsgActivity", [friendId]);
    };
    //我打项目相关的js
    window.KalaGameGuide = {};
    KalaGameGuide.getMyGame = function() {
        exec(null, null, "KalaGameGuide", "getMyGame", []);
    };
    KalaGameGuide.openGameTabActivity = function(title, url, gameId, packageName, icon) {
        exec(null, null, "KalaGameGuide", "openGameTabActivity", [title, url, gameId, packageName, icon]);
    }
    KalaGameGuide.openActivity = function(title, url, isList, strClass) {
        var fullScrean = (document.location.href.indexOf("&fullScrean=true") != -1);
        exec(null, null, "KalaGameGuide", "openActivity", [title, url, fullScrean, isList, strClass]);
    }
    KalaGameGuide.checkVersion = function() {
        exec(null, null, "KalaGameGuide", "checkVersion", []);
    }
    KalaGameGuide.calCacheSize = function() {
        exec(null, null, "KalaGameGuide", "calCacheSize", []);
    }
    KalaGameGuide.clearCache = function() {
        exec(null, null, "KalaGameGuide", "clearCache", []);
    }
    KalaGameGuide.changeFontSize = function() {
        exec(null, null, "KalaGameGuide", "changeFontSize", []);
    }
    KalaGameGuide.showUserGuide = function() {
        exec(null, null, "KalaGameGuide", "showUserGuide", []);
    }
    KalaGameGuide.showRecommendedApps = function() {
        exec(null, null, "KalaGameGuide", "showRecommendedApps", []);
    }
    KalaGameGuide.showShare = function(title, content) {
        exec(null, null, "KalaGameGuide", "showShare", [title, content]);
    }
    KalaGameGuide.copy = function(contact) {
        exec(null, null, "KalaGameGuide", "copy", [contact]);
    }
    KalaGameGuide.startWeiXin = function() {
        exec(null, null, "KalaGameGuide", "startWeiXin", []);
    }
    KalaGameGuide.startQQ = function() {
        exec(null, null, "KalaGameGuide", "startQQ", []);
    }
    KalaGameGuide.setupPopupWindow = function() {
        exec(null, null, "KalaGameGuide", "setupPopupWindow", []);
    }
    KalaGameGuide.getGameBtnFlag = function(callback) {
        exec(callback, null, "KalaGameGuide", "getGameBtnFlag", []);
    }
    KalaGameGuide.setGameBtnFlag = function(flag) {
        exec(null, null, "KalaGameGuide", "setGameBtnFlag", [flag]);
    }
    KalaGameGuide.getReplyNoticeFlag = function(callback) {
        exec(callback, null, "KalaGameGuide", "getReplyNoticeFlag", []);
    }
    KalaGameGuide.setReplyNoticeFlag = function(flag) {
        exec(null, null, "KalaGameGuide", "setReplyNoticeFlag", [flag]);
    }
    KalaGameGuide.getNewGameNoticeFlag = function(callback) {
        exec(callback, null, "KalaGameGuide", "getNewGameNoticeFlag", []);
    }
    KalaGameGuide.setNewGameNoticeFlag = function(flag) {
        exec(null, null, "KalaGameGuide", "setNewGameNoticeFlag", [flag]);
    }
    KalaGameGuide.playAudio = function(src) {
        exec(null, null, "KalaGameGuide", "playAudio", [src]);
    }
    KalaGameGuide.pauseAudio = function(src) {
        exec(null, null, "KalaGameGuide", "pauseAudio", [src]);
    }
    KalaGameGuide.hasFavData = function(gameId, url, callback) {
        exec(callback, null, "KalaGameGuide", "hasFavData", [gameId, url]);
    }
    KalaGameGuide.setFavData = function(json) {
        exec(null, null, "KalaGameGuide", "setFavData", [json]);
    }
    KalaGameGuide.removeFavData = function(gameId, strategyUrl) {
    	exec(null, null, "KalaGameGuide", "removeFavData", [gameId, strategyUrl]);
    }
})();
