define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib');
    exports.init = init;
    var V = {
        'setVersion'  : function() {
            var $version = $('#version');
            var strVersion = '';
            if (window.KalaGameGuide) {
                strVersion = '版本：' + lib.getVersionString();
            } else {
                strVersion = '版本：未知';
            }
            // 设置版本号
            $version.html(strVersion);
            lib.handleLoadPageReady();
        },
        'execSetting' : function(strSetting, strContact) {
            if (window.KalaGameGuide) {
                console.log('=========================going to execute: ' + strSetting)
                if (strSetting === 'copy') {
                    if (strContact && KalaGameGuide[strSetting]) {
                        console.log('====================================contact: ' + strContact)
                        KalaGameGuide[strSetting](strContact);
                    }
                } else {
                    KalaGameGuide[strSetting] && KalaGameGuide[strSetting]();
                }
            } else {
                lib.showTip("网页版本无此功能！");
            }
        }
    };
    var C = {
        init                     : function() {
            C.bindCheckSettingsEvent();
            $("#aboutwrap").show();
            
            $(".ai_vername").text(lib.getParam("appName"));
            $("#extra_info").text(lib.getParam("appId") + ", " + lib.getParam("channel"));
            var count = 0;
            $(".aboutus").on(gc.click, function() {
            	if (count++ >= 3) {
            		$("#extra_info").css("visibility", "visible");
            	}
            });
            
        },
        'bindCheckSettingsEvent' : function() {
            // 显示客户端相关设置
            var $wrap = $('#aboutwrap');
            $wrap.on(gc.click, 'li', function() {
                var $this = $(this);
                var strSetting = $this.attr('settingsType');
                if (!strSetting) {
                    return;
                }
                var strContact = null;
                switch (strSetting) {
                    case 'copy':
                        strContact = C.copy($this);
                        break;
                    case 'score':
                        if (window.KalaGame && KalaGame.score) {
                            KalaGame.score();
                        }
                        return;
                }
                V.execSetting(strSetting, strContact);
            });
        },
        'copy'                   : function($this) {
            var strContact = $this.attr('contact');
            switch ($this.attr("id")) {
                case "btn_wx":
                    if (window.KalaGameGuide && KalaGameGuide.startWeiXin) {
                        KalaGameGuide.startWeiXin();
                    }
                    lib.showTip("复制微信号成功！");
                    break;
                case "btn_qq":
                    if (window.KalaGameGuide && KalaGameGuide.startQQ) {
                        KalaGameGuide.startQQ();
                    }
                    lib.showTip("复制QQ群号成功！");
                    break;
            }
            return strContact;
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        V.setVersion();
        // 可升级，显示气泡提示
        gc.showBubble = function() {
            $('[settingsType="checkVersion"]').find('p').addClass('updatable');
        }
    }
});
