define(function(require, exports, module) {
    var $ = require('jquery'), lib = require('lib'), com = require('com'), lazyload = require('lazyload');
    exports.init = init;
    var M = {
        'formatDataList' : function(arrList) {
            if (!arrList) {
                return;
            }
            var arrDataList = [];
            // 过滤游戏
            var isAllFav = com.isAllFav();
            var strAppId = lib.getParam('gameId');
            if (!isAllFav) {
                for (var i = 0, len = arrList.length; i < len; i++) {
                    if (arrList[i].appId == strAppId) {
                        arrDataList.push(arrList[i]);
                    }
                }
            } else {
                arrDataList = arrList;
            }
            // 生成列表
            var len = arrDataList.length;
            if (len) {
                for (var i = 0; i < len; i++) {
                    var obj = arrDataList[i];
                    var arrStrategy = obj.strategy;
                    obj.strategyList = lib.template2(arrStrategy, '#guidelist_template');
                }
            }
            return arrDataList;
        }
    };
    var V = {
        'showFavorite' : function(arrList) {
            var arrDataList = M.formatDataList(arrList);
            if (arrDataList && arrDataList.length) {
                $('#nonefavorwrap').hide();
                // 设置模板
                var isAllFav = com.isAllFav();
                var strTemplate = isAllFav ? '#allguide_template' : '#guide_template';
                var $html = $(lib.template2(arrDataList, strTemplate));
                $('#allguide').html($html).show();
            } else {
                $('#allguide').hide();
                if (com.isAllFav()) {
                    $('#fav_all').show();
                    $('#fav_app').hide();
                } else {
                    $('#fav_all').hide();
                    $('#fav_app').show();
                }
                $('#nonefavorwrap').show();
            }
        }
    };
    var C = {
        'init'        : function() {
            C.bindEvents();
            C.initFavList();
        },
        'bindEvents'  : function() {
            // 显示app攻略列表
            com.bindShowAppEvent('h4[redirect]');
            // 显示攻略详情
            com.bindShowStrategyEvent('li[redirect]', true);
        },
        'initFavList' : function() {
            var strFavList = localStorage.getItem('favList');
            var arrFavList = strFavList && JSON.parse(strFavList) || [];
            // 网页测试数据
            if (!window.KalaGameGuide && lib.getParam('hideFavList') != 'true') {
                arrFavList = [
                    {
                        "url"      : "http://10.235.4.205/strategy/42980/index.html?20130704171426",
                        "name"     : "保卫萝卜(CarrotFantasy)",
                        "icon"     : "http://10.235.4.205/app/icon/fd/64/42980_9afdc45609efae92190c67010420fd64.small.png",
                        "appId"    : "42980",
                        "strategy" : [
                            {
                                "url"   : "http://10.235.4.205/strategy/42980/7001/39/39.html?20130514113122",
                                "title" : "《保卫萝卜》天际12攻略",
                                "class" : ""
                            },
                            {
                                "url"   : "http://10.235.4.205/strategy/42980/7001/38/38.html?20130417154316",
                                "title" : "《保卫萝卜》天际11攻略",
                                "class" : ""
                            }
                        ]
                    },
                    {
                        "url"      : "http://10.235.4.205/strategy/10001/index.html?20130704171429",
                        "name"     : "宠物城堡",
                        "icon"     : "http://10.235.4.205/app/icon/52/7f/10001_b762759abd0266903af7947003f1527f.small.png",
                        "appId"    : "10001",
                        "strategy" : [
                            {
                                "url"   : "http://10.235.4.205/strategy/10001/237/237.html?20130419153516",
                                "title" : "宠物城堡图片测试",
                                "class" : "icons icons_player"
                            }
                        ]
                    }
                ];
            }
            lib.handleLoadPageReady();
            V.showFavorite(arrFavList);
        }
    };
    // 初始化执行一次
    // C.init();
    function init() {
        console.log('===========================html class: ' + $('html').attr('class'));
        C.init();
    }
})