define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib'), com = require('com');
    exports.init = init;
    var V = {
        'execSetting'       : function(strSetting, isClearCache) {
            if (window.KalaGameGuide) {
                console.log('=========================going to execute: ' + strSetting)
                if (isClearCache) {
                    lib.confirm('确定要清除缓存吗', function(index) {
                        if (index !== 1) {
                            return;
                        }
                        // 清除web缓存
                        localStorage.clear();
                        // 清除下载缓存
                        KalaGameGuide[strSetting] && KalaGameGuide[strSetting]();
                        $('#cacheSize').html('0.00B');
                    });
                } else {
                    switch (strSetting) {
                        case 'noImageMode':
                            V.toggleImageView();
                            break;
                        case 'showButton':
                            V.toggleGameBtn();
                            break;
                        case 'replyNotice':
                            V.toggleBtnState("btn_notice", KalaGameGuide.setReplyNoticeFlag);
                            break;
                        case 'gameNotice':
                            V.toggleBtnState("new_game_notice", KalaGameGuide.setNewGameNoticeFlag);
                            break;
                        default :
                            KalaGameGuide[strSetting] && KalaGameGuide[strSetting]();
                            break;
                    }
                }
            } else {
                lib.showTip("网页版本无此功能！");
            }
        },
        'initPage'          : function() {
            // 是否显示游戏按钮
            V.toggleGameBtn(true);
            // MIUI设置悬浮窗
            V.togglePopupWindow();
            // 初始化无图状态
            V.initImageView();
            // 初始化金牌客服回复设置
            V.getBtnState("btn_notice", KalaGameGuide.getReplyNoticeFlag);
            // 初始化新游戏攻略通知设置
            V.getBtnState("new_game_notice", KalaGameGuide.getNewGameNoticeFlag);
            // 显示选择框
            $('#settingwrap').find('.si_ckbox').show();
        },
        'toggleImageView'   : function() {
            var $noImageMode = $('#noImageMode');
            var strNoImageMode = $noImageMode.attr('noImageMode');
            if (strNoImageMode == 1) {
                strNoImageMode = 0;
                $noImageMode.removeClass('on');
            } else {
                strNoImageMode = 1;
                $noImageMode.addClass('on');
            }
            $noImageMode.attr('noImageMode', strNoImageMode);
            localStorage.setItem('noImageMode', strNoImageMode);
        },
        'initImageView'     : function() {
            var $noImageMode = $('#noImageMode');
            var strNoImageMode = localStorage.getItem('noImageMode') || 1;
            if (strNoImageMode == 1) {
                $noImageMode.addClass('on');
            } else if (strNoImageMode == 0) {
                $noImageMode.removeClass('on');
            }
            $noImageMode.attr('noImageMode', strNoImageMode);
        },
        'togglePopupWindow' : function() {
            var strPopupWindow = lib.getParam('popupWindow');
            if (strPopupWindow == 1) {
                $('#setupPopupWindow').show();
            }
        },
        'toggleGameBtn'     : function(isPageInit) {
            if (!window.KalaGameGuide) {
                return;
            }
            var $btn = $('#show_btn');
            if (isPageInit) {
                KalaGameGuide.getGameBtnFlag(function(strFlag) {
                    if (strFlag == 'on') {
                        $btn.addClass('on');
                    } else {
                        $btn.removeClass('on');
                    }
                    $btn.attr('showButton', strFlag);
                });
            } else {
                var strShowButton = $btn.attr('showButton');
                if (strShowButton == 'on') {
                    lib.confirm('关闭我打按钮后，你将不能在游戏中使用攻略、变速功能 :)', function(idx) {
                        if (idx !== 1) {
                            return;
                        }
                        $btn.removeClass('on');
                        strShowButton = 'off';
                        $btn.attr('showButton', strShowButton);
                        KalaGameGuide.setGameBtnFlag(strShowButton);
                    }, '关闭我打按钮');
                } else {
                    $btn.addClass('on');
                    strShowButton = 'on';
                    $btn.attr('showButton', strShowButton);
                    KalaGameGuide.setGameBtnFlag(strShowButton);
                }
            }
        },
        getBtnState : function(id, callback) {
        	callback(function(strFlag) {
        		var $btn = $("#" + id);
                if (strFlag == 'on') {
                    $btn.addClass('on');
                } else {
                    $btn.removeClass('on');
                }
                $btn.attr('replyNotice', strFlag);
            });
        },
        toggleBtnState : function(id, callback) {
        	var $btn = $("#" + id);
        	var strShowButton = $btn.attr('replyNotice');
            if (strShowButton == 'on') {
                $btn.removeClass('on');
                strShowButton = 'off';
            } else {
                $btn.addClass('on');
                strShowButton = 'on';
            }
            $btn.attr('replyNotice', strShowButton);
            callback(strShowButton);
        }
    };
    var C = {
        init                     : function() {
            C.bindCheckSettingsEvent();
            if (!lib.getParam("isSingleVersion")) {
            	$('._faq_notice').show();
            }
        },
        'bindCheckSettingsEvent' : function() {
            // 显示客户端相关设置
            $('#settingwrap').on(gc.click, 'li', function() {
                var $this = $(this);
                var strSetting = $this.attr('settingsType');
                if (!strSetting) {
                    return;
                }
                // 是否显示confirm框
                var isClearCache = (strSetting === 'clearCache');
                V.execSetting(strSetting, isClearCache);
            });
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        lib.handleLoadPageReady();
        V.initPage();
        // 显示缓存回调
        gc.showCacheSize = function(strSize) {
            $('#cacheSize').html(strSize);
        }
        // 获取并显示缓存大小
        if (window.KalaGameGuide && KalaGameGuide.calCacheSize) {
            KalaGameGuide.calCacheSize();
        } else {
            $('#cacheSize').html('0.00B');
        }
    }
});
