define(function(require, exports, module) {
    var $ = require('jquery'), lib = require('lib'), com = require('userCom'), slider = require('slider'), lazyload = require('lazyload');
    exports.init = init;
    // 列表默认的显示数目
    var defaultCount = 3;
    var screenshots = null;
    var appInfo = null;
    var stateMap = {
        '-1' : "队列中...",
        0    : "连接中...",
        1    : "暂停", /** 下载中 */
        2    : "安装", /** 下载完毕 */
        3    : "继续", /** 暂停下载 */
        4    : "重新下载" /** 下载失败 */
    };
    gc.getDownloadInfo = function(result) {
        console.log('gc.getDownloadInfo:' + JSON.stringify(result));
        if (!result) {
            return;
        }
        result.completeSize = parseInt(result.completeSize);
        result.fileSize = parseInt(result.fileSize);
        result.downloadState = parseInt(result.downloadState);
        switch (result.downloadState) {
            case 1:
            case 3:
                $('.dlctrl').show();
                //更新进度条
                var percent = (result.completeSize / result.fileSize * 100).toFixed(2) + "%";
                var size = (result.completeSize / 1024 / 1024).toFixed(2) + "MB/" + (result.fileSize / 1024 / 1024).toFixed(2) + "MB";
                $('.progess').css('width', percent);
                $('#btn_download').text(percent + "   (" + size + ")");
                break;
            case 2:
                $('.dlctrl').hide();
                $('#btn_download').text(stateMap[result.downloadState]);
                $('.progess').css('width', "100%");
                return;
            default:
                //对于-1和4
                if (result.downloadState > 0) {
                    $('.dlctrl').hide();
                    $('#btn_download').text(stateMap[result.downloadState]);
                    $('.progess').css('width', "0%");
                    return;
                }
        }
        /*
         if (lib.getParam('page') == 'game-content') {
         //每隔秒刷新一次下载管理列表
         lib.setTimeout(M.getDownloadInfo, 1000);
         }
         */
    };
    gc.setButtonText = function(text) {
        $('#btn_download').text(text);
    };
    var M = {
        getDownloadInfo : function() {
            if (window.KalaGameClient && KalaGameClient.getDownloadInfo) {
                var gameId = lib.getParam('gameId');
                KalaGameClient.getDownloadInfo(gameId);
            }
        },
        getGameInfo     : function() {
            var gameId = lib.getParam('gameId');
            lib.getAppInfo(gameId, function(objResult) {
                appInfo = objResult;
                if (appInfo.result == 1) {
                    appInfo.url = encodeURI(appInfo.downloadUrl);
                    if (window.KalaGameClient && KalaGameClient.initApp) {
                        appInfo.mininumOSCode = appInfo.mininumOSCode || "10";
                        KalaGameClient.initApp(JSON.stringify(appInfo));
                        //KalaGameClient.getButtonText(appInfo.appId, appInfo.packageName, appInfo.mininumOSCode, appInfo.versionCode, appInfo.url);
                    } else {
                        $('#btn_download').text("下载");
                    }
                    V.showGameIntroduction(appInfo);
                } else {
                    // 失败，显示提示信息
                    lib.showTip(appInfo.msg);
                }
            });
        },
        formatList      : function(gameInfo) {
            var capturesList = [];
            var captures = gameInfo.captures;
            if (!captures) {
                return capturesList;
            }
            var capturesArr = captures.split('|');
            for (var i = 0, len = capturesArr.length; i < len; i++) {
                var size = capturesArr[i].match(/(\d+)\*(\d+)/);
                var image = {
                    thumb : capturesArr[i]
                };
                if (size) {
                    image.width = size[1];
                    image.height = size[2];
                } else {
                    image.width = '';
                    image.height = '';
                }
                capturesList.push(image);
            }
            return capturesList;
        }
    };
    var V = {
        showGameIntroduction : function(gameInfo) {
            var gameScreenHtml = '';
            var gameScreenList = M.formatList(gameInfo);
            var gameDescription = gameInfo.description;
            // 如果图片不存在，则增加默认图片
            gameInfo['backgroundImage'] = gameInfo['backgroundImage'] || gc.cssUrl + 'style/' + gc.theme + '/module/img/gamedetail_bg.jpg';
            gameInfo['fileSizeString'] = gameInfo['fileSizeString'] || (gameInfo['fileSize'] / 1024 / 1024) + "MB";
            // 显示游戏基本信息
            lib.template(gameInfo, '#game_info');
            $('#game_info img').lazyload();
            // 显示游戏截图
            if (gameScreenList.length) {
                gameScreenHtml = lib.template2(gameScreenList, '#game_screen_template');
                $('#game_screen .slider').html(gameScreenHtml);
                var direction = parseInt(gameInfo.direction) ? 'horizontal' : 'vertical';
                $('#game_screen').removeClass('horizontal vertical').addClass(direction);
                C.getScreenSlider();
                // 存储游戏截图列表
                for (var i = 0, len = gameScreenList.length; i < len; i++) {
                    gameScreenList[i].normal = gameScreenList[i].thumb.replace(/\.thumb\./, '.normal.');
                }
                // 缩略图方向
                var screenshots_direction = parseInt(gameInfo.direction) ? 'screenshots_horizontal' : 'screenshots_vertical';
                screenshots = {
                    direction : screenshots_direction,
                    list      : gameScreenList
                };
            } else {
                $('#game_screen').html('暂无截图');
            }
            // 没有游戏描述时，隐藏简介
            if (!gameDescription) {
                $('#gameov_intro pre').html('暂无内容');
            }
            if ($('pre').height() <= $('#gameov_intro').height()) {
                $('p.more').hide();
            }
        },
        showMore             : function($parent) {
            var $section = $parent.find('pre[name]').parent();
            $section.css('max-height', '');
            $section.css('height', $section.find('pre').height());
            $parent.find('p.more').hide();
        },
        hideMore             : function($parent) {
            var $section = $parent.find('pre[name]').parent();
            $section.css('height', 155);
            $parent.find('p.more').show();
        }
    };
    var C = {
        init            : function() {
            // 绑定游戏介绍显示更多事件
            $('#section_intro, #section_version').on(gc.tap, 'pre, p.more', function() {
                var $this = $(this);
                var $parent = $this.parentsUntil('#game_continfo').last();
                var $showMore = $parent.find('p.more');
                if (!$showMore.length) {
                    return;
                }
                if ($showMore.is(':visible')) {
                    V.showMore($parent);
                } else {
                    V.hideMore($parent);
                }
            });
            // 绑定显示大图事件
            $('#game_screen').on(gc.tap, 'img', function() {
                if (!screenshots) {
                    return;
                }
                var $this = $(this);
                // 设置当前点击图片的索引
                var index = $('#game_screen img').index($this);
                screenshots.index = index + 1;
                var json = JSON.stringify(screenshots);
                localStorage.setItem('screenshots', json);
                if (window.KalaGameUi && KalaGameUi.startBigImgActivity) {
                    KalaGameUi.startBigImgActivity(json);
                } else {
                    lib.redirect('game-screenshots');
                }
            });
            //太诡异了，增加一个touchstart就没问题了，不然盖世3会点击不灵
            $('#show_all_posts').on(gc.touchstart, function() {
            });
            //绑定下载按钮事件
            $(".btn_start").on(gc.click, function() {
                var text = $(this).find('#btn_download').text();
                switch (text) {
                    case '下载':
                    case '更新':
                        if (window.KalaGameClient && KalaGameClient.download) {
                            KalaGameClient.download(appInfo.appId, appInfo.url, appInfo.appName, appInfo.icon, appInfo.packageName, appInfo.fileSize);
                            changeDownloadState();
                        } else {
                            document.location.href = appInfo.url;
                        }
                        break;
                    case '继续':
                        KalaGameClient.continueDownload(appInfo.appId);
                        changeDownloadState();
                        break;
                    case '安装':
                        KalaGameClient.installApp(appInfo.url);
                        break;
                    case '重新下载':
                        KalaGameClient.redownload(appInfo.appId, appInfo.url, appInfo.appName, appInfo.icon, appInfo.packageName, appInfo.fileSize);
                        changeDownloadState();
                        break;
                    case '开始游戏':
                        KalaGameClient.startApp(appInfo.packageName);
                        break;
                }
            });
            $('.btn_start').on(gc.click, '.goon', function() {
                KalaGameClient.continueDownload(appInfo.appId);
                return false;
            });
            $('.btn_start').on(gc.click, '.stop', function() {
                $('#btn_ctrl').removeClass('stop').addClass('goon');
                KalaGameClient.pauseDownload(appInfo.appId);
                return false;
            });
            $('.btn_start').on(gc.click, '.del', function() {
                KalaGameClient.cancelDownload(appInfo.appId);
                return false;
            });
            function changeDownloadState() {
                M.getDownloadInfo();
                $('#btn_download').text(stateMap['-1']);
                $('.dlctrl').show();
                $('#btn_ctrl').removeClass('goon').addClass('stop');
            }
        },
        getScreenSlider : function() {
            $('#game_screen').iosSlider({
                snapToChildren       : true,
                responsiveSlideWidth : true,
                onSlideChange        : function() {
                    $.updateLazyload();
                }
            });
            // 防止高度设置错误
            $('#game_screen').height('');
            $('#game_screen img').lazyload();
        }
    }
    // 初始化执行一次
    C.init();
    function init() {
        if (lib.getParam("channel") != "client") {
            $("#btn_download").parent().show();
            $("#btn_download").parent().show();
            $("#gamerank_tab").show();
            $("#gameov_about").removeClass("notab");
        }
        // 初始化游戏介绍
        M.getGameInfo();
        M.getDownloadInfo();
    }
});
