define(function(require, exports, module) {
	var $ = require('jquery'), lib = require('lib'), lazyload = require('lazyload');
	var stateMap = {
	    '-1' : "队列中...",
        0 : "连接中...",
        1 : "暂停", /** 下载中 */
        2 : "安装", /** 下载完毕 */
        3 : "继续", /** 暂停下载 */
        4 : "重新下载" /** 下载失败 */
	};
	
	exports.init = init;
	var cacheResult;

	gc.getDownloadList = function(result) {
	    cacheResult = result;
	    downloadMap ={};
	    for (var i in result) {
	        downloadMap[result[i]['gameId']] = result[i];
	        result[i]['btnText'] = stateMap[result[i]['downloadState']];
	        result[i]['percent'] = (result[i]['completeSize'] / result[i]['fileSize'] * 100).toFixed(2); 
	    }
	    //console.log(result);
	    lib.template2(result, '#downloadManage_template', '#downloadManage');
	    if (lib.getParam('page') == 'game-download') {
	    	    //每隔秒刷新一次下载管理列表
	    	    lib.setTimeout(M.getDownloadList, 1000);
	    }
	};
	
	gc.getUpdateList = function(result) {
	    console.log('getUpdateList');
	    lib.template2(result, '#updateList_template', '#updateList');
	};
    
	var M = {
		getDownloadList : function() {		    
		    if (window.KalaGameClient) {
		         KalaGameClient.getDownloadList();
		    }
		},
		getUpdateList : function() {
			if (window.KalaGameClient) {
		         KalaGameClient.getUpdateList();
		    }
		}
	};

	var C = {
		init : function() {
		    $('#downloadManage').on(gc.click, '.btn', function() {
		        if (!window.KalaGameClient) { return; }
		        var gameId = this.id;
		        
		        var text = $(this).text();
		        switch(text) {
		        	case '安装':
			        	KalaGameClient.installApp(gameId);
			        	break;
		        	case '暂停':
		        	    $(this).text(stateMap[3]);
			        	KalaGameClient.pauseDownload(gameId);
			        	break;
		        	case '继续':
		        	    $(this).text(stateMap['-1']);
			        	KalaGameClient.continueDownload(gameId);
			        	break;
		        	case '重新下载':
		        	    $(this).text(stateMap['-1']);
		        	    var info = downloadMap[gameId];
		        	    KalaGameClient.redownload(info['gameId'], info['url'], info['gameName'], info['gameIcon'], info['packageName']);
			        	break;
		        }
		    });
		    
		    C.bindBackEvent();
		},
      bindBackEvent : function() {
            // 回退时隐藏大图显示
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {
                console.log('gc.historyBack');
                var page = lib.getParam('page');
                //console.log(' JSON.stringify(cacheResult):' +  JSON.stringify(cacheResult));
                localStorage.setItem("game-download-downloadList", JSON.stringify(cacheResult));

                historyCallback();
                gc.historyBack = historyCallback;
            };
        }
	};

	function initOnce() {
	    // 初始化一次
	    C.init();
	    
	    var downloadMap;
	    cacheResult = localStorage.getItem("game-download-downloadList");
	    if (cacheResult) {
	        cacheResult = JSON.parse(cacheResult);
	        //console.log('cacheResult2:' + cacheResult);
	        cacheResult && gc.getDownloadList(cacheResult);
	    }
	}

	function init() {
		//获取推荐列表
		M.getDownloadList();
	}
	
	initOnce();
});
