define(function(require, exports, module) {
    var $ = require('jquery'), lib = require('lib'), com = require('gameComm'), slider = require('slider'), lazyload = require('lazyload');
    exports.init = init;
    var screenshots = null;

    var M = {};

    var V = {
        showEmotions : function() {
            var dataList = [];
            var $game_facebox = $('#game_facebox'), $content = $('#pageswarp');

            // 表情框的宽度
            var width = $game_facebox.width();
            // 页面可用高度
            var height = window.innerHeight - parseInt($content.css('paddingTop'));
            var emotionWidth = 60, emotionHeight = 60;
            // 因为样式问题(margin -1)，计算时要+1
            var col = Math.floor(width / (emotionWidth + 1)), row = Math.floor((height - emotionHeight) / (emotionHeight + 1));
            // 页面可现实表情数量
            var total = col * row;
            // 计算需要多少页现实表情
            var emotions = com.emotions;
            emotionCount = emotions.length;
            var page = Math.floor(emotionCount / total) + 1;
            var perPage = page > 1 ? total : emotionCount;
            // 清空
            $('#emotion_slider').html('');
            $('#emotion_button').html('');

            for (var i = 0; i < page; i++) {
                var face_html = '';
                var face_num = perPage;
                if (i == page - 1) {
                    face_num = emotionCount % total;
                }

                face_html = lib.template2(emotions.slice(perPage * i, perPage * (i + 1)), '#emotions_template');
                dataList.push({
                    face_html : face_html
                });
            }

            var $html = $(lib.template2(dataList, '#emotions_page_template'));
            $html.appendTo('#emotion_slider');
            if (page > 1) {
                var $btn = $(lib.template2(dataList, '#emotions_button_template'));
                $btn.appendTo('#emotion_button');

                $('#emotion_button').show();
            } else {
                $('#emotion_button').hide();
            }

            V.generateEmotionsSlider(page);
        },
        generateEmotionsSlider : function(page) {
            var options = {
                snapToChildren : true,
                responsiveSlideWidth : true
            };

            if (page > 1) {
                options.navSlideSelector = $('.iosSliderButtons .button');
                options.onSlideChange = V.switchSliderButton;
                options.onSliderLoaded = V.switchSliderButton;
                options.onSlideComplete = V.switchSliderButton;
            }
            $('#emotions').iosSlider(options);

        },
        switchSliderButton : function(args) {
            var index = args.currentSlideNumber;
            var $slider = $(args.sliderObject);
            var $buttons = $slider.parent().find('.iosSliderButtons .button');
            var $image = $slider.find('img').eq(index);

            $buttons.removeClass('selected');
            $buttons.eq(index).addClass('selected');
            $.updateLazyload();
        }
    };

    var C = {
        init : function() {
            $('#emotions').on(gc.click, '[emotion]', function() {
                var $this = $(this);
                var emotion = $this.attr('emotion');

                localStorage.setItem('emotion', emotion);
                gc.historyBack();
            });
        },
        bindBackEvent : function() {
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {
                // 销毁slider
                C.clearSlider();
                // 解绑屏幕旋转事件
                window.KalaGame && $(window).off('orientationchange');

                lib.historyBack();
                gc.historyBack = historyCallback;
            };

            window.KalaGame && C.bindOrientationchangeEvent();
        },
        clearSlider : function() {
            // 销毁slider
            var $slider = $('#emotions');
            $slider.iosSlider('destroy');
            // 清空html
            $slider.find('.slider, .iosSliderButtons').html('');
            // 去除样式
            $('#emotions, .slider, .iosSliderButtons').removeAttr('style');
            screenshots = null;
        },
        bindOrientationchangeEvent : function() {
            $(window).on('orientationchange', function() {
                console.log('device direction: ' + window.orientation)
                C.clearSlider();
                // 显示表情，延时执行，等待旋转完毕
                lib.setTimeout(function() {
                    V.showEmotions();
                }, 750);
            });
        }
    };

    // 初始化执行一次
    C.init();

    function init() {
        // 显示表情
        V.showEmotions();
        C.bindBackEvent();

        lib.setSessionItem('emotion_page', 1);
    }

});
