define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), com = require('gameComm');
    exports.init = init;
    var M = {
        createQuestion : function(params) {
            var url = lib.bbsUrl + 'question/createQuestion';
            params.appId = lib.getParam('gameId');
            lib.postCross(url, params, function(response) {
                if (response.result == 1) {
                    lib.showTip('提交成功！');
                    lib.setSessionItem('latestQuestion', JSON.stringify(response));
                    //刷新客服列表页面
                    if (window.KalaGame && KalaGame.sendBroadcast) {
                        KalaGame.sendBroadcast("game-faq_list", "init");
                    }
                    lib.historyBack();
                } else {
                    if (response.ret == -6001) {
                        lib.showVcode(function() {
                            M.createQuestion(params);
                        });
                    }
                    // 失败，显示提示信息
                    lib.showTip(response.msg);
                }
            }, {
                'sendBtn' : '#q_submit'
            });
        },
        submitQuestion : function() {
            var data = lib.getFormData('#faq_subpost');
            if (!data) {
                return;
            }
            // 验证问题类型
            var type = $('#category').val();
            if (!type) {
                lib.showTip('请选择分类！');
                return;
            }
            data.type = type;
            M.createQuestion(data);
        },
        'setBbsTitle'  : function() {
            var url = lib.gameUrl + 'app/getAppInfo';
            var params = {
                appId : lib.getParam('gameId')
            };
            lib.postCross(url, params, function(objResult) {
                if (objResult.result == 1) {
                    var $bbs = $('#open_bbs');
                    $bbs.find('span.linkitem').html(objResult.appName + '社区');
                    $bbs.show();
                }
            }, {
                cache     : "must",
                noLoading : true
            });
        }
    };
    var V = {
        'toggleFAQType' : function() {
            var strNoType = lib.getParam('noType');
            if (strNoType === 'true') {
                // 默认分类设置为`其它`，并隐藏分类
                $('#category').val(3);
                $('#btn_category').hide();
                $('#post_content').css('min-height', '150px');
            } else {
                $('#category').val('');
                $('#btn_category').show();
            }
            $("#faq_subpost").show();
        }
    };
    var C = {
        init                    : function() {
            // 获取客服时间
            com.getWorkingHours();
            C.bindOpenBbsEvent();
            C.bindSelectCategoryEvent();
            $('#q_submit').on(gc.click, function() {
                M.submitQuestion();
            });
        },
        bindSelectCategoryEvent : function() {
            var $btn = $('#btn_category');
            $btn.on(gc.click, function() {
                // 设置菜单显示内容及事件回调
                var option = {};
                option['title'] = "选择分类";
                option['data'] = [
                    {
                        text : "充值相关",
                        name : 1
                    },
                    {
                        text : "账号相关",
                        name : 2
                    },
                    {
                        text : "其它",
                        name : 3
                    }
                ];
                option['callback'] = function(name) {
                    var $this = $('[qt=' + name + ']');
                    var html = $.trim($this.html());
                    $('#category').val(name);
                    $btn.find('span').html(html);
                };
                if (window.KalaGameUi && KalaGameUi.showSelectDialog) {
                    KalaGameUi.showSelectDialog(option);
                } else {
                    lib.showOptMenu(option)
                }
            });
        },
        resetCategoryList       : function() {
            $('#category').val('');
            var $span = $('#btn_category').find('span');
            $span.html($span.attr('content'));
            V.toggleFAQType();
        },
        bindBackEvent           : function() {
            // 回退时隐藏操作菜单
            if (!window.KalaGame) {
                var historyCallback = gc.historyBack;
                gc.historyBack = function() {
                    $('#_menu').hide();
                    lib.historyBack();
                    gc.historyBack = historyCallback;
                };
            }
        },
        'bindOpenBbsEvent'      : function() {
            $('#open_bbs').on(gc.click, function() {
                if (window.KalaGameUi && KalaGameUi.openBbsListActivity) {
                    var title = $('#open_bbs').find('span.linkitem').text();
                    KalaGameUi.openBbsListActivity('game-bbslist', 'gameId=' + lib.getParam('gameId'), title);
                } else {
                    lib.redirect('game-bbslist');
                }
            });
        }
    }
    // 初始化执行一次
    C.init();
    function init() {
        // 清空上一次保存的分类
        M.setBbsTitle();
        C.resetCategoryList();
        C.bindBackEvent();
    }
});
