define(function(require, exports, module) {
    var $ = require('jquery'), lib = require('lib'), com = require('userCom'), slider = require('slider'), lazyload = require('lazyload');
    exports.init = init;
    // 默认显示的游戏个数
    var defaultGameCount = 10 * lib.listCountMultiples();
    var M = {
        getRecommendGameList : function() {
            var url = lib.gameUrl + 'app/getAppList';
            var params = {
                category : 'all',
                start    : $('#game_hotgamebox li').length,
                count    : defaultGameCount
            };
            lib.postCrossList(url, params, function(response) {
                if (response.result == 1) {
                    V.showRecommendGameList(response);
                } else {
                    // 失败，显示提示信息
                    lib.showTip(response.msg);
                }
            }, function() {
                M.getRecommendGameList();
            });
        },
        getAdvertising       : function() {
            var url = lib.gameUrl + 'app/getAdvertising';
            lib.postCross(url, function(responseData) {
                if (responseData.result == 1) {
                    V.showAdvertising(responseData.list);
                } else {
                    // 失败，显示提示信息
                    lib.showTip(responseData.msg);
                }
            }, {
                cache : true
            });
        },
        loadMore             : function() {
            var $gameBox = $('#game_hotgamebox');
            var $spinner = $('#spinner_list');
            if ($gameBox.attr('hasMore') != 'true') {
                $spinner.hide();
                return;
            }
            // 延迟显示
            var timeout = parseInt($spinner.attr('timeout'));
            lib.setTimeout(M.getRecommendGameList, timeout);
        }
    };
    var V = {
        showRecommendGameList : function(response) {
            // 显示缓存数据
            var $html = lib.showCacheList2(response, '#game_list_template', '#game_hotgamebox');
            // 绑定延迟加载图片事件
            $html && $html.find('img').lazyload();
        },
        showAdvertising       : function(dataList) {
            var $adSlider = $('.slider');
            // 如果有ad就不再次加载了
            var $ad = $adSlider.find('.ad');
            if ($ad.length) {
                return;
            }
            var html, button;
            var $adButton = $('.iosSliderButtons');
            if (dataList.length) {
                html = lib.template2(dataList, '#ads_scroller_template');
                button = lib.template2(dataList, '#scroller_button_template');
                $adSlider.html(html);
                $adButton.html(button);
                // 设置广告位滚动
                C.initSlider();
            } else {
                // 隐藏广告位
                $adSlider.hide();
                $adSlider.next().hide();
            }
        }
    };
    var C = {
        init                : function() {
            C.bindShowGameEvent();
            // 加载推荐游戏列表
            M.getRecommendGameList();
        },
        initSlider          : function() {
            var timeout = parseInt($('.iosSlider').attr('timeout'));
            $('.iosSlider').iosSlider({
                autoSlide            : true,
                autoSlideTimer       : timeout,
                snapToChildren       : true,
                responsiveSlideWidth : true,
                infiniteSlider       : true,
                navSlideSelector     : $('.iosSliderButtons .button'),
                onSlideChange        : C.switchSliderButton,
                onSliderLoaded       : C.switchSliderButton
            });
        },
        switchSliderButton  : function(args) {
            $(args.sliderObject).parent().find('.iosSliderButtons .button').removeClass('selected');
            $(args.sliderObject).parent().find('.iosSliderButtons .button:eq(' + args.currentSlideNumber + ')').addClass('selected');
        },
        'bindShowGameEvent' : function() {
            // 从列表打开
            $('#game_hotgamebox').on(gc.tap, 'li', function() {
                var $this = $(this);
                var strAppId = $this.attr('appId');
                var strAppName = $this.attr('appName');
                if (window.KalaGameClient && KalaGameClient.startGameActivity) {
                    console.log("KalaGameClient.startGameActivity(" + strAppId + ");");
                    KalaGameClient.startGameActivity(strAppId);
                } else {
                    lib.setParam('title', strAppName);
                    lib.setParam('gameId', strAppId);
                    lib.setParam('tabType', 'game_detail');
                    lib.setParam('tab', 'game-content');
                    lib.redirect('common-tab');
                }
            });
            // 从广告位处打开
            $('.iosSlider').on(gc.tap, '.item', function() {
                var $image = $(this).find('img');
                var strAppId = $image.attr('appId');
                var strAppName = $this.attr('appName');
                if (window.KalaGameClient && KalaGameClient.startGameActivity) {
                    console.log("KalaGameClient.startGameActivity(" + strAppId + ");");
                    KalaGameClient.startGameActivity(strAppId);
                } else {
                    lib.setParam('title', strAppName);
                    lib.setParam('gameId', strAppId);
                    lib.setParam('tabType', 'game_detail');
                    lib.setParam('tab', 'game-content');
                    lib.redirect('common-tab');
                }
            });
        }
    };
    // 初始化一次
    C.init();
    function init() {
        //获取推荐列表
        M.getAdvertising();
        //绑定滚动条事件
        lib.bindScrollEvent(M.loadMore, $('#game_hotgamebox'));
    }
});
