define(function(require, exports, module) {
	var $ = require('jquery'), lib = require('lib'), com = require('userCom'), slider = require('slider'), lazyload = require('lazyload');
	exports.init = init;
	var screenshots = null, imgIndex = 0;

	var M = {};

	var V = {
		showScreenshots : function() {
			screenshots = JSON.parse(localStorage.getItem('screenshots'));
			// 没有截图，不做处理
			if (!screenshots) {
				return;
			}

			// 隐藏头部和底部
			$('.pageguide_wrap, .pagetabs_wrap').hide();

			// 设置论坛显示大图标识
			if (!screenshots.__screenshot) {
				$('#screenshots').attr('screenshot', 0);
			}

			var list = screenshots.list;
			$('.slider').html(lib.template2(list, '#screenshots_template'));
			$('.iosSliderButtons').html(lib.template2(list, '#screenshots_button_template'));

			if (imgIndex) {
				V.generateScreenshotsSlider(imgIndex);
			} else {
				V.generateScreenshotsSlider(screenshots.index);
			}

			V.initImg();
		},
		initImg : function() {
			var $imgs = $('#screenshots').find('img');
			var option = {
				effect : "show",
				effect_speed : 0
			};

			// 判断大图标识，如果是论坛则设置图片高度自适应
			var screenshot = $('#screenshots').attr('screenshot');

			// 旋转背景图
			if (screenshots.direction == 'screenshots_horizontal') {
				//给图片设置横屏的样式
				$imgs.addClass("horizontalImg");

				//旋转横图比较坑，必须限制好宽度、高度，它不会等比例缩放
				//这里的宽度旋转后会变成高度，所以需要设置高度
				var docHeight = $(document).height();
				$imgs.css('min-width', docHeight);

				var $slider = $('#screenshots_slider');

				$imgs.each(function() {
					var src = $(this).attr('data-original');
					var matchs = /_(\d+)\*(\d+)\./.exec(src);
					if (matchs && matchs.length) {
						//计算图片的宽高比例来设置宽度
						$(this).height(matchs[1] / matchs[2] * docHeight);
					} else {
						//这个是有问题的情况，直接让图自适应
						$(this).css('height', '');
					}

					var width = $slider.width() - docHeight;
					if (width < 0) {
						$(this).css('left', ($slider.width() - docHeight) / 2 + "px");
					}
				});

				option['beforeLoad'] = function() {
					$(this).removeClass("horizontalImg");

					//限制图片高度，不设置宽度，这样可以让宽度等比例缩放
					var width = $(this).width();
					$(this).height(width);
					$(this).css('min-width', '');
					$(this).css('left', '');
				};
			} else if (screenshot == 0) {
				var docHeight = $(document).height();
				$imgs.each(function() {
					var $this = $(this);
					var src = $this.attr('src');
					if (!src) {
						return;
					}
					var size = src.match(/_(\d+)\*(\d+)\./);

					if (size && size.length) {
						$this.height(size[2] < docHeight ? size[2] : docHeight);
					}
				});

				// TODO : 手机上显示不正确的临时解决方案
				if (window.KalaGame) {
					$('#screenshots .item').height(document.height);
					$('#screenshots .item').width(document.width);
				}
			} else {
				$imgs.removeClass("horizontalImg");
			}

			// 绑定延迟加载图片事件
			$imgs.lazyload(option);
		},
		generateScreenshotsSlider : function(startIndex) {
			$('#screenshots_slider').iosSlider({
				snapToChildren : true,
				responsiveSlideWidth : true,
				//responsiveSlideContainer : true,
				startAtSlide : startIndex,
				navSlideSelector : $('.iosSliderButtons .button'),
				onSlideChange : V.switchSliderButton,
				onSliderLoaded : V.switchSliderButton,
				onSlideComplete : V.switchSliderButton
			});

		},
		switchSliderButton : function(args) {
			var index = args.currentSlideNumber;
			var $slider = $(args.sliderObject);
			var $buttons = $slider.parent().find('.iosSliderButtons .button');
			var $image = $slider.find('img').eq(index);

			// 保存当前查看图片的索引
			imgIndex = index + 1;

			$buttons.removeClass('selected');
			$buttons.eq(index).addClass('selected');
			$.updateLazyload();
		}
	};

	var C = {
		init : function() {
			$('#screenshots_slider').on(gc.click, '.item', function() {
				gc.historyBack();
			});
		},
		bindBackEvent : function() {
			// 回退时隐藏大图显示
			var historyCallback = gc.historyBack;
			gc.historyBack = function() {
				$('.pageguide_wrap, .pagetabs_wrap').show();
				// 销毁slider
				C.clearSlider(true);
				// 解绑屏幕旋转事件
				$(window).off('orientationchange');

				lib.historyBack();
				gc.historyBack = historyCallback;
			};

			C.bindOrientationchangeEvent();
		},
		clearSlider : function(clearIndex) {
			// 销毁slider
			var $slider = $('#screenshots_slider');
			$slider.iosSlider('destroy');
			// 清空html
			$slider.find('.slider, .iosSliderButtons').html('');
			// 去除样式
			$('#screenshots_slider, .slider, .iosSliderButtons').removeAttr('style');
			// 去除标识
			$('#screenshots').removeAttr('screenshot');
			screenshots = null;
			if (clearIndex) {
				imgIndex = 0;
			}
		},
		bindOrientationchangeEvent : function() {
			$(window).on('orientationchange', function() {
				console.log('device direction: ' + window.orientation)
				C.clearSlider();
				// 显示大图，延时执行，等待旋转完毕
				lib.setTimeout(function() {
					V.showScreenshots();
				}, 750);
			});
		}
	};

	function init() {
		// 回退时隐藏大图显示
		C.bindBackEvent();
		// 显示大图
		V.showScreenshots();
	}


	C.init();
});
