define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), com = require('gameComm'), slider = require('slider');
    exports.init = init;
    // 默认可以上传的图片张数
    // var allowedCount = 5;
    var uploadImages = [];
    var M = {
        submitPost : function() {
            var $btn = $('#btn_post');
            var btnDisabled = $btn.hasClass('ontimer');
            if (!btnDisabled) {
                var params = lib.getFormData('#game_subpost');
                // 验证失败则不发请求
                if (!params) {
                    return;
                }
                var url = lib.bbsUrl + 'forum/createPost';
                params.appId = lib.getParam('gameId');
                $btn.addClass('ontimer');
                lib.showLoading();
                if (window.KalaGame && KalaGame.createPost) {
                    // 添加图片，token，uid信息
                    lib.getDefaultData(params);
                    params.images = uploadImages;
                    var str_params = JSON.stringify(params);
                    console.log("createPost:" + str_params);
                    KalaGame.createPost(str_params);
                } else {
                    lib.postCrossIframe(url, params, '#createPost', 'createPostFrame');
                }
            }
        }
    };
    var V = {
        readURL     : function(evt) {
            var allowedTypes = ['image/gif', 'image/jpeg', 'image/png'];
            var val = this.value;
            var files = evt.target.files;
            if (files && files[0]) {
                var file_type = files[0].type;
                if (allowedTypes.indexOf(file_type) == -1) {
                    alert('文件格式错误！');
                    return;
                } else if (file_type == allowedTypes[0]) {
                    $('#btn_photo_library').addClass('nobg');
                } else {
                    $('#btn_photo_library').removeClass('nobg');
                }
                var reader = new FileReader();
                reader.readAsDataURL(files[0]);
                reader.onload = function(e) {
                    V.preImage(e.target.result);
                };
            }
        },
        clearStored : function(clearImage) {
            uploadImages = [];
            // 清除file和内容
            var $btn = $('#btn_photo_library');
            $btn.removeClass("showdel nobg");
            $btn.html('<input type="file" />');
            $('#uploadImage').find('input').remove();
            !clearImage && $('#post_content, #post_title').val('');
        },
        preImage    : function(icon) {
            //暂时一次只能上传一张，先清空uploadImages
            uploadImages = [];
            // 保存上传的图片的实际地址
            uploadImages.push(icon);
            var $img = $('<img />');
            var $btn = $('#btn_photo_library');
            // 图片路径
            $img.attr('src', icon);
            // 清空之前选择的图片
            $btn.find('img').remove();
            $img.appendTo($btn);
            //增加显示删除按钮
            $btn.addClass("showdel");
            var $uploadImage = $('#uploadImage');
            $uploadImage.find('input').remove();
            $btn.find('input').attr('name', 'image1').appendTo($uploadImage);
            $input = $('<input type="file" />');
            $input.appendTo($btn);
        }
    };
    var C = {
        init                 : function() {
            //苹果的渠道暂时不能上传图片
            if (lib.getParam("channel") == "apple") {
                $('#btn_photo_library').hide();
                $('.arrow').hide();
            }
            // 绑定显示帖子内容事件
            $('#btn_post').on(gc.click, M.submitPost);
            $('#btn_emotions').on(gc.click, function() {
                com.showEmotions();
            });
            // 插入图片
            C.bindUploadImageEvent();
        },
        bindUploadImageEvent : function() {
            if (!window.KalaGame) {
                $('#createPost').on('change', 'input[type="file"]', V.readURL);
            }
            $('#btn_photo_library').on(gc.click, function() {
                // $('#add_pic input').focus().trigger(gc.click);
                if (uploadImages.length) {
                    lib.confirm("确定要删除图片吗？", function(index) {
                        if (index == 1) {
                            V.clearStored(true);
                        }
                    });
                } else if (window.KalaGame && KalaGame.getPicture) {
                    C.getPicture();
                } else if (navigator.camera) {
                    // 本地的上传方法
                    var type = "PHOTOLIBRARY";
                    // 或者CAMERA
                    C.uploadNativePhoto(type);
                }
            });
        },
        getPicture           : function() {
            window.KalaGame.getPicture(onSuccess, onFail, false);
            function onSuccess(imageUri) {
                console.log("onSuccess, imageUri:" + imageUri);
                V.preImage(imageUri);
            }

            function onFail(message) {
                console.log("onFail, message:" + message);
            }
        },
        uploadNativePhoto    : function(type) {
            var option = {
                quality         : 75,
                targetWith      : 800,
                targetHeight    : 800,
                destinationType : Camera.DestinationType.FILE_URI,
                sourceType      : Camera.PictureSourceType[type]
            };
            navigator.camera.getPicture(onSuccess, onFail, option);
            function onSuccess(imageUri) {
                console.log("onSuccess, imageUri:" + imageUri);
                V.preImage(imageUri);
            }

            function onFail(message) {
                console.log("onFail, message:" + message);
            }
        }
    };
    // 初始化一次
    C.init();
    function init() {
        $('#emotion_wrap').addClass('invisible');
        $('#btn_post').removeClass('ontimer');
        // 去除错误提示的样式
        $('#post_content').removeClass('hover');
        // postMessage回调
        gc.msgCallback = function(response) {
            lib.hideLoading();
            console.log("msgCallback response:" + JSON.stringify(response));
            $('#btn_post').removeClass('ontimer');
            if (response.result == 1) {
                // 保存刚发的帖子信息
                localStorage.setItem('latestPost', JSON.stringify(response));
                // 发帖成功清除内容
                V.clearStored();
                lib.showTip('发帖成功！');
                lib.historyBack();
            } else {
                if (response.ret == -6001) {
                    lib.showVcode(M.submitPost);
                } else if (response.ret == -201) {
                    lib.showConfirmBind();
                }
                // 失败，显示提示信息
                lib.showTip(response.msg);
            }
        };
    }
});
