define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), com = require('gameComm'), slider = require('slider');
    exports.init = init;
    var uploadImages = [];
    var M = {
        submitReply : function() {
            var $btn = $('#btn_reply');
            var btnDisabled = $btn.hasClass('ontimer');
            if (!btnDisabled) {
                var params = {};
                var $image = $('#uploadImage').find('input');
                if (!$image.length) {
                    params = lib.getFormData('#game_subreply');
                    // 验证失败则不发请求
                    if (!params) {
                        return;
                    }
                } else {
                    var content = $('#reply_content').val();
                    params.content = content;
                }
                // 回复的回复
                // var replyId = lib.getParam('replyId');
                // if (replyId) {
                // params.parentId = replyId;
                // } else {
                // $('input[name="parentId"]').remove();
                // delete params.parentId;
                // }
                var url = lib.bbsUrl + 'forum/replyPost';
                params.appId = lib.getParam('gameId');
                params.postId = lib.getParam('postId');
                params.boardId = lib.getParam('boardId');
                $btn.addClass('ontimer');
                lib.showLoading();
                if (window.KalaGame && KalaGame.createReply) {
                    // 添加图片，token，uid信息
                    lib.getDefaultData(params);
                    params.images = uploadImages;
                    var str_params = JSON.stringify(params);
                    console.log("createReply:" + str_params);
                    KalaGame.createReply(str_params);
                } else {
                    lib.postCrossIframe(url, params, '#createReply', 'createReplyFrame');
                }
            }
        }
    };
    var V = {
        readURL     : function(evt) {
            var allowedTypes = ['image/gif', 'image/jpeg', 'image/png'];
            var val = this.value;
            var files = evt.target.files;
            if (files && files[0]) {
                var file_type = files[0].type;
                if (allowedTypes.indexOf(file_type) == -1) {
                    alert('文件格式错误！');
                    return;
                } else if (file_type == allowedTypes[0]) {
                    $('#btn_photo_library').addClass('nobg');
                } else {
                    $('#btn_photo_library').removeClass('nobg');
                }
                var reader = new FileReader();
                reader.readAsDataURL(files[0]);
                reader.onload = function(e) {
                    V.preImage(e.target.result);
                };
            }
        },
        clearStored : function(clearImage) {
            uploadImages = [];
            // 清除file和内容
            var $btn = $('#btn_photo_library');
            $btn.removeClass("showdel");
            $btn.find('img').removeClass('nobg').remove();
            $btn.html('<input type="file" />');
            $('#uploadImage').find('input').remove();
            !clearImage && $('#reply_content').val('');
        },
        preImage    : function(icon) {
            uploadImages = [];
            // 保存上传的图片的实际地址
            uploadImages.push(icon);
            var $img = $('<img />');
            var $btn = $('#btn_photo_library');
            //增加显示删除按钮
            $btn.addClass("showdel");
            // 图片路径
            $img.attr('src', icon);
            // 清空之前选择的图片
            $btn.find('img').remove();
            $img.appendTo($btn);
            var $uploadImage = $('#uploadImage');
            $uploadImage.find('input').remove();
            $btn.find('input').attr('name', 'image1').appendTo($uploadImage);
            $input = $('<input type="file" />');
            $input.appendTo($btn);
        }
    };
    var C = {
        init                 : function() {
            //苹果的渠道暂时不能上传图片
            if (lib.getParam("channel") == "apple") {
                $('#btn_photo_library').hide();
                $('.arrow').hide();
            }
            // 绑定显示帖子内容事件
            $('#btn_reply').on(gc.click, M.submitReply);
            $('#btn_emotions').on(gc.click, function() {
                com.showEmotions();
            });
            // 插入图片
            C.bindUploadImageEvent();
        },
        bindUploadImageEvent : function() {
            if (!window.KalaGame) {
                $('#createReply').on('change', 'input[type="file"]', V.readURL);
            }
            $('#btn_photo_library').on(gc.click, function() {
                // $('#add_pic input').focus().trigger(gc.click);
                if (uploadImages.length) {
                    lib.confirm("确定要删除图片吗？", function(index) {
                        if (index == 1) {
                            V.clearStored(true);
                        }
                    });
                } else if (window.KalaGame && KalaGame.getPicture) {
                    C.getPicture();
                }
            });
        },
        getPicture           : function() {
            window.KalaGame.getPicture(onSuccess, onFail, false);
            function onSuccess(imageUri) {
                console.log("onSuccess, imageUri:" + imageUri);
                V.preImage(imageUri);
            }

            function onFail(message) {
                console.log("onFail, message:" + message);
            }
        },
        bindToggleUplodEvent : function() {
            var replyId = lib.getParam('replyId');
            var $btn = $('#btn_photo_library');
            if (replyId) {
                $btn.hide();
            } else if (lib.getParam("channel") != "apple") {
                $btn.show();
            }
        }
    }
    // 初始化一次
    C.init();
    function init() {
        $('#emotion_wrap').addClass('invisible');
        // 去除错误提示的样式
        $('#reply_content').removeClass('hover');
        // 控制上传图片的显示
        C.bindToggleUplodEvent();
        // postMessage回调
        gc.msgCallback = function(response) {
            lib.hideLoading();
            $('#btn_reply').removeClass('ontimer');
            if (response.result == 1) {
                // 保存刚发的帖子信息
                lib.setSessionItem('latestReply', JSON.stringify(response));
                // 回复成功清除内容
                V.clearStored();
                lib.historyBack();
                lib.showTip('回复成功！');
            } else {
                if (response.ret == -6001) {
                    lib.showVcode(M.submitReply);
                } else if (response.ret == -201) {
                    lib.showConfirmBind();
                }
                // 失败，显示提示信息
                lib.showTip(response.msg);
            }
        }
    }
});
