define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib');
    exports.init = init;

    var historyCallback = null;

    var V = {
        showVcode : function() {
            var $vc = $('#vc');
            var $vcode = $('#vcode');

            // 清空输入框
            $('[name=vcodenum]').val('');

            // 如果是缓存的图片，怎删除重新添加
            if ($vc.attr('src')) {
                $vc.remove();
                $('<img id="vc" alt="验证码" title="">').insertBefore($('#vcLink').find('span'));
            }

            $vcode.find('#vc').attr('src', lib.userUrl + 'vcode.php?rd=' + Math.random() + '&token=' + localStorage.getItem('token'));
        },
        hideVcode : function() {
            // 存储验证码并清空
            var $imgVcode = $('[name=vcodenum]');
            localStorage.setItem('imgVcode', $imgVcode.val());
            $imgVcode.val('');

            lib.historyBack();
        }
    };

    var C = {
        init : function() {
            $('#vcLink').on(gc.click, function() {
                $(this).find('#vc').attr('src', lib.userUrl + 'vcode.php?rd=' + Math.random() + '&token=' + localStorage.getItem('token'));
            });

            $('#btn_cancel').on(gc.click, function() {
                gc.vcodeCancelCallback && gc.vcodeCancelCallback();
                $('[name=vcodenum]').val('');
                V.hideVcode();
            });

            $('#btn_send').on(gc.click, function() {
                var $vcode = $('#vcode');
                if (lib.getFormData($vcode)) {
                    V.hideVcode();
                }
            });
        },
        bindBackEvent : function() {
            // 回退时隐藏大图显示
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {
                lib.historyBack();
                gc.historyBack = historyCallback;
            };
        }
    };

    // 初始化执行一次
    C.init();

    function init() {
        // 隐藏回复按钮
        if (window.KalaGameUi && KalaGameUi.hideReplyBtn) {
            KalaGameUi.hideReplyBtn();
        }

        V.showVcode();
        C.bindBackEvent();
    }

});
