define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib');
    exports.init = init;

    function enterGame() {
        gc.reportAction("library", "completeRegister", 0, 'activenotice');

        var appId = lib.getParam('appId');
        var uid = localStorage.getItem('uid');
        var token = localStorage.getItem('token');
        var openId = lib.getOpenAuthInfo(appId, 'openId');
        var openToken = lib.getOpenAuthInfo(appId, 'openToken');
        if (uid && token) {
            //登陆过了就直接进入
            if (window.KalaGame) {
                KalaGame.session(uid, token, openId, openToken);
            } else {
                lib.redirect('user-info');
                // 去除登录注册的特殊样式
                lib.removeCustomizedStyle(appId);
            }

            localStorage.setItem('isOldUser', 1);
            // 清除注册时保留的密码
            localStorage.removeItem('pwd');
            localStorage.removeItem('oldPwd');
        } else {
            //如果没有登录过则需要登录
            lib.authLogin(true);
        }
    }

    var C = {
        init : function() {
            $('#startGame').on(gc.click, enterGame);
        },
        bindBackEvent : function() {
            // 回退时隐藏大图显示
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {
            };
        }
    };

    // 初始化执行一次
    C.init();

    function init() {
		lib.loadCustomizedStyle();
        //2秒后自动进入游戏
        lib.setTimeout(function() {
            enterGame();
        }, 2000);
        C.bindBackEvent();
    }

});
