define(function(require, exports, module) {
	var $ = require('zepto'), lib = require('lib'), com = require('userCom');
	exports.init = init;

	// 默认平台ID，默认的重新发送等待时间
	var platformId = 1000, defaultResendTime = 60;
	var checkTimer;

	// 关于ajax 的方法
	var M = {
		checkResetPwd : function() {
			var inputVcode = $('#inputVcode').val();
			if (inputVcode == '') {
				lib.showTip('请输入激活码');
				return;
			}

			lib.postCross(lib.userUrl + 'account/comfirmResetPwd', {
				inputVcode : inputVcode,
				platformId : platformId
			}, function(data) {
				if (data.result == 1) {
					gc.resetNickName = data.nickName;
					lib.redirect('user-reset_password');
				} else {
					lib.showTip(data.msg);
				}
			});
		},
		sendResetPwdCode : function() {
			lib.postCross(lib.userUrl + 'account/sendResetPwdCode', {
				platformId : platformId,
				isInit : 0,
				imgVcode : $('[name=vcodenum]').val()
			}, function(data) {
				V.handleResponse(data);
			}, {
				noLoading : true
			});
		}
	};

	var V = {
		handleResponse : function(data, isInit) {
			C.freshTip(data.sendResult, data.lastTime);

			if (data.result == 1) {
				if (data.interval >= 0) {
					lib.setSessionItem('resend', 0);
					lib.setSessionItem('checkCount', data.interval);

					C.check();
					window.clearInterval(checkTimer);
					checkTimer = lib.setInterval(C.check, 1000);
				}
			} else {
				if (data.ret == -6001) {
					window.clearInterval(checkTimer);
					lib.setSessionItem('checkCount', 0);
					$('#resendMobile').val('发送激活码');
					$('#resendMobile').removeClass('ontimer');

					if (!isInit) {
						lib.showVcode(M.sendResetPwdCode);
					}
				}
				lib.showTip(data.msg);
			}
		},
		resendMobile : function() {
			var checkCount = parseInt(lib.getSessionItem('checkCount')) || 0;
			if (checkCount > 0) {
				return false;
			}

			C.freshTip(1);
			V.doUpdateResetPwd();
			window.clearInterval(checkTimer);
			checkTimer = lib.setInterval(C.check, 1000);

			lib.setSessionItem('checkCount', defaultResendTime);
			var resend = parseInt(lib.getSessionItem('resend')) || 0;
			if (!resend) {
				return false;
			}

			M.sendResetPwdCode();
		},
		doUpdateResetPwd : function(num) {
			var sendTip = '秒后可重新发送';
			var sendBtn = '重新发送激活码';
			var checkCount = parseInt(lib.getSessionItem('checkCount')) || 0;
			var text = checkCount + sendTip;
			if (checkCount <= 0) {
				lib.setSessionItem('resend', 1);

				$('#resendMobile').val(sendBtn);
				$('#resendMobile').removeClass('ontimer');
			} else {
				$('#resendMobile').val(text);
				$('#resendMobile').addClass('ontimer');
			}
		}
	};

	var C = {
		init : function() {
			$('#resendMobile').on(gc.click, function() {
				V.resendMobile();
			});

			$('#submit').on(gc.click, M.checkResetPwd);

			$('.btn_back').on(gc.click, function() {
				window.clearInterval(checkTimer);
			});
		},
		initAccount : function() {
			var account = localStorage.getItem('account');
			if (account) {
				$('#account').val(account);
			} else {
				account = $('#account').val();
				localStorage.setItem('account', account);
			}

			gc.pattern = com.getPattern(platformId, account);
			$('.mobile').html(account);
			if (gc.pattern == 1) {
				$('#content1').html("一条校验短信");
				$('#content2').html("手机");
			} else {
				$('#content1').html("一封校验邮件");
				$('#content2').html("邮箱");
			}
		},
		pageInit : function() {
			lib.setSessionItem('resend', 0);

            // 处理验证码
            var strResetCodeResponse = lib.getSessionItem('resetCodeResponse');
            var objResult = JSON.parse(strResetCodeResponse);
            if (objResult) {
                V.handleResponse(objResult, true);
                // 清除缓存数据
                lib.removeSessionItem('resetCodeResponse');
            } else {
                M.sendResetPwdCode();
            }
		},
		check : function() {
			var checkCount = parseInt(lib.getSessionItem('checkCount')) || 0;
			lib.setSessionItem('checkCount', --checkCount);

			if (checkCount <= 0) {
				window.clearInterval(checkTimer);
			}
			V.doUpdateResetPwd(checkCount);
		},
		freshTip : function(sendResult, lastTime) {
			// tip的显示和内容
			if (sendResult == 2) {
				$('.msg').show();
				$('#sendedInfoTip').show();
				if ( typeof (lastTime) != 'undefined') {
					$('#lastTime').html(com.makeTimeTip(lastTime));
				}
				$('#sendInfoTip').hide();
			} else if (sendResult == 1) {
				$('.msg').show();
				$('#sendedInfoTip').hide();
				$('#sendInfoTip').show();
			} else {
				$('.msg').show();
				$('#sendedInfoTip').hide();
				$('#sendInfoTip').hide();
			}
		}
	};

	// 初始化执行一次
	C.init();

	function init() {
		lib.loadCustomizedStyle();
		// 设置默认的重发时间
		lib.setSessionItem('checkCount', defaultResendTime);

		C.initAccount();
		C.pageInit();
	}

});
