define(function(require, exports, module) {
	var $ = require('zepto'), lib = require('lib'), md5 = require('md5');
	exports.init = init;

	// 默认平台ID
	var platformId = 1000;

	var M = {
		completeRegister : function(nickName, pwd) {
			var data = {
				registerType : 'easy',
				nickName : nickName,
				platformId : platformId,
				pwd : pwd,
				appId : lib.appId
			};
			data.uuid = window.device && device.uuid;

			lib.postCross(lib.userUrl + 'register/completeRegister', data, function(data) {
				data.token && localStorage.setItem('token', data.token);
				data.uid && localStorage.setItem('uid', data.uid);
				data.openId && lib.setOpenAuthInfo(lib.appId, 'openId', data.openId);
				data.openToken && lib.setOpenAuthInfo(lib.appId, 'openToken', data.openToken);

				if (data.result == 1) {
					// 不存在openId，进入激活页面
					if (lib.appId && lib.appId != 10000 && !data.openId) {
						lib.redirect('user-activation');
						return;
					}

					localStorage.setItem('isOldUser', 1);
					if (window.KalaGame) {
						KalaGame.session(data.uid, data.token, data.openId, data.openToken);
					} else {
						lib.redirect('user-info');

						// 去除登录注册的特殊样式
						lib.removeCustomizedStyle(lib.appId);
					}
				} else {
					lib.showTip(data.msg);
				}
			});
		}
	};

	var V = {
		checkPassword : function(password) {
			if (!password.length) {
				return false;
			}

			for (var i = 0; i < password.length; i++) {
				var chr = password.charCodeAt(i);
				if (chr > 255) {
					lib.showTip('密码格式错误!');
					return false;
				} else if (chr == 32) {
					lib.showTip('密码不能包含空格符!');
					return false;
				}
			}
			return true;
		}
	};

	var C = {
		init : function() {
			C.showPassword();
			$('#submitCompleteInfo').on(gc.click, C.submitCompleteInfo);
		},
		submitCompleteInfo : function() {
			// 绑定表单验证事件
			var data = lib.getFormData($('#complete_info'));
			if (!data) {
				return;
			}

			var pwd = $("#comple_info_pwd").val();
			if (!V.checkPassword(pwd)) {
				return;
			}

			var $nickName = $('#nickName');
			var nickName = $nickName.val();

			if (nickName) {
				pwd = md5.sha1(md5.sha1(pwd));
				M.completeRegister(nickName, pwd);
			} else {
				lib.addFocus($nickName);
			}
		},
		showPassword : function() {
			$('#showpassword').on('click', function() {
				var $this = $(this);
				var val = $this.html();
				var $password = $('#comple_info_pwd');

				if ($.trim(val) == '显示') {
					$this.html('隐藏');
					$password.attr('type', 'text');
				} else {
					$this.html('显示');
					$password.attr('type', 'password');
				}
			});
		},
		bindBackEvent : function() {
			// 回退时隐藏大图显示
			var historyCallback = gc.historyBack;
			gc.historyBack = function() {				
				lib.confirm("确定要退出本次注册吗？", function(index) {
			        switch (index) {
			        case 1:
		                 historyCallback();
		                 gc.historyBack = historyCallback;
		                 break;
			        case 2:
			            window.KalaGame && KalaGame.setIsBusy && KalaGame.setIsBusy(false);
			            break;
			        }
			    }
			};
		}
	};

	// 初始化执行一次
	C.init();

	function init() {
		lib.loadCustomizedStyle();
		
		var account = localStorage.getItem('account');
		$('#mobile').html((account || ''));
		C.bindBackEvent();
	}

});
