define(function(require, exports, module) {
    var $ = require('jquery'), lib = require('lib'), lazyload = require('lazyload'), com = require('user/js/common.js');
    exports.init = init;
    // 选择的图标的路径
    var strUploadImage = '';
    // 当前选择的头像
    var nAvatarIndex = 0;
    // 重新上传图片的标识
    var isReupload = false;
    var objUserInfo = {};
    var M = {
        getAccountInfo : function() {
            var strUrl = lib.userUrl + 'detail/getBaseInfo';
            lib.postCross(strUrl, function(objResult) {
                if (objResult.result == 1) {
                    V.showAccountInfo(objResult);
                } else {
                    //失败，直接退回登录页面
                    lib.redirect("user-login");
                }
            }, {
                'noLoading' : false
            })
        },
        uploadAvatar   : function() {
            var objData = {
                index : isReupload ? nAvatarIndex : $('#edit_avatar').find('img').length
            };
            lib.showLoading();
            if (window.KalaGame && KalaGame.uploadAvatar) {
                // 添加图片，token，uid信息
                objData = lib.getDefaultData(objData);
                objData.image = strUploadImage;
                var strParams = JSON.stringify(objData);
                console.log("uploadAvatar:" + strParams);
                KalaGame.uploadAvatar(strParams);
            } else {
                var strUrl = lib.userUrl + 'detail/uploadIcon';
                lib.postCrossIframe(strUrl, objData, '#uploadAvatar', 'uploadAvatarFrame');
            }
        },
        deleteIcon     : function() {
            var strUrl = lib.userUrl + 'detail/deleteIcon';
            var objData = {
                index : nAvatarIndex
            };
            lib.postCross(strUrl, objData, function(objResult) {
                if (objResult.result == 1) {
                    var $avatar = $('#edit_avatar');
                    $avatar.find('.editheadimg').eq(nAvatarIndex).remove();
                    V.toggleAddPic();
                } else {
                    lib.showTip(objResult.msg);
                }
            });
        },
        formatData     : function(objData) {
            if (!objData) {
                return;
            }
            for (var k in objData) {
                if (k == 'sex') {
                    if (objData[k] == 0) {
                        //                        objData['cSex'] = '女';
                        objData.sex = 0;
                    } else {
                        //                        objData['cSex'] = '男';
                        objData.sex = 1;
                    }
                }
            }
            if (!objData.sign) {
                objData.sign = com.defaultSign;
            }
            return objData;
        },
        formatDataList : function(arrDataList) {
            if (!arrDataList || !arrDataList.length) {
                return;
            }
            var arrList = [];
            for (var i = 0, len = arrDataList.length; i < len; i++) {
                arrList.push({
                    icon : arrDataList[i]
                });
            }
            return arrList;
        }
    };
    var V = {
        showAccountInfo : function(objResult) {
            var objData = M.formatData(objResult.data);
            if (!objData) {
                return;
            }
            objUserInfo = $.extend({}, objData);
            lib.template(objData, '#basic_info');
            // 设置性别
            $('input[name="sex"]').eq(objData.sex).attr('checked', true);
            delete objData.sex;
            lib.template(objData, '#basic_info');
            // 显示头像列表
            V.showIcons(objData);
        },
        showIcons       : function(objResult) {
            var arrDataList = M.formatDataList(objResult.icons);
            if (!arrDataList) {
                return;
            }
            var $html = $(lib.template2(arrDataList, '#avatar_template'));
            $('#edit_avatar .editheadimg').not('#btn_add_pic').remove();
            $html.insertBefore($('#btn_add_pic'));
            $html && $html.find('img').lazyload();
            V.toggleAddPic();
        },
        readURL         : function(objEvent) {
            var arrAllowedTypes = ['image/gif', 'image/jpeg', 'image/png'];
            var arrFiles = objEvent.target.files;
            if (arrFiles && arrFiles[0]) {
                var strFileType = arrFiles[0].type;
                if (arrAllowedTypes.indexOf(strFileType) == -1) {
                    alert('文件格式错误！');
                    return;
                }
                var objReader = new FileReader();
                objReader.readAsDataURL(arrFiles[0]);
                objReader.onload = function(e) {
                    V.uploadImage(e.target.result);
                };
            }
        },
        'isModified'    : function() {
            var objBasicInfo = lib.getFormData('#basic_info');
            if (!objBasicInfo) {
                return;
            }
            var objExtraInfo = lib.getFormData('#extra_info');
            if (!objExtraInfo) {
                return;
            }
            var objData = $.extend({}, objBasicInfo, objExtraInfo);
            for (var k in objData) {
                if (objUserInfo[k] == objData[k]) {
                    delete objData[k];
                }
            }
            if ($.isEmptyObject(objData)) {
                return;
            }
            return objData;
        },
        'updateInfo'    : function() {
            var objData = V.isModified();
            if (!objData) {
                lib.showTip('请先修改信息再保存');
                return;
            }
            com.updateBaseInfo(objData, function() {
                // 更新信息
                var k, v;
                for (k in objUserInfo) {
                    v = objData[k];
                    if (typeof v !== 'undefined') {
                        objUserInfo[k] = v;
                    }
                }
                gc.historyBack();
            });
        },
        clearStored     : function() {
            isReupload = false;
            strUploadImage = '';
            nAvatarIndex = 0;
            $('#uploadImage').find('input').remove();
        },
        uploadImage     : function(strIcon) {
            // 保存上传的图片的实际地址
            strUploadImage = strIcon;
            // 清空之前选择的图片
            var $avatar = $('#btn_add_pic');
            var $uploadImage = $('#uploadImage');
            $uploadImage.find('input').remove();
            $avatar.find('input').attr('name', 'image').appendTo($uploadImage);
            $input = $('<input type="file" />');
            $input.appendTo($avatar);
            M.uploadAvatar();
        },
        showPrevImg     : function(objResult) {
            var strIcon = objResult.data;
            if (strIcon) {
                var $add_pic = $('#btn_add_pic');
                var arrDataList = [
                    {
                        icon : strIcon
                    }
                ];
                var $html = $(lib.template2(arrDataList, '#avatar_template'));
                if (isReupload) {
                    $('#edit_avatar').find('.editheadimg').eq(nAvatarIndex).replaceWith($html);
                } else {
                    $html.insertBefore($add_pic);
                }
                $html && $html.find('img').lazyload();
                V.toggleAddPic();
            }
        },
        toggleAddPic    : function() {
            var $add_pic = $('#btn_add_pic');
            var $avatar = $('#edit_avatar');
            if ($avatar.find('img').length == 4) {
                $add_pic.hide();
            } else {
                $add_pic.show();
            }
        }
    };
    var C = {
        init                 : function() {
            C.bindSaveInfoEvent();
            C.bindShowOptMenuEvent();
            C.bindUploadImageEvent();
        },
        bindUploadImageEvent : function() {
            if (window.KalaGame && KalaGame.getPicture) {
                $('#btn_add_pic').on(gc.click, function() {
                    KalaGame.getPicture && C.uploadNativePhoto();
                });
            } else {
                $('#uploadAvatar').on('change', 'input[type="file"]', V.readURL);
            }
        },
        uploadNativePhoto    : function() {
            window.KalaGame.getPicture(onSuccess, onFail, true);
            function onSuccess(imageUri) {
                console.log("onSuccess, imageUri:" + imageUri);
                V.uploadImage(imageUri);
            }

            function onFail(message) {
                console.log("onFail, message:" + message);
            }
        },
        bindShowOptMenuEvent : function() {
            if (lib.getParam("channel") == "apple") {
                $(".addheadimg").html('').click(function() {
                    lib.showTip("对不起，暂不支持此功能。");
                });
            } else {
                $('#edit_avatar').on(gc.click, 'img', function() {
                    nAvatarIndex = $('#edit_avatar img').index($(this));
                    // 设置菜单显示内容及事件回调
                    var objOption = {};
                    objOption['title'] = '选择操作';
                    objOption['data'] = [
                        {
                            text : '删除头像',
                            name : 1
                        },
                        {
                            text : '查看大图',
                            name : 2
                        },
                        {
                            text : '重新上传',
                            name : 3
                        }
                    ];
                    objOption['callback'] = function(name) {
                        switch (name) {
                            case 1:
                                M.deleteIcon();
                                break;
                            case 2:
                                lib.showOriginalImg('#edit_avatar', nAvatarIndex);
                                break;
                            case 3:
                                isReupload = true;
                                $('#btn_add_pic input').focus().trigger(window.KalaGame ? gc.click : 'click');
                                break;
                            default:
                                $('#_menu').hide();
                                break;
                        }
                    };
                    if (window.KalaGameUi && KalaGameUi.showSelectDialog) {
                        KalaGameUi.showSelectDialog(objOption);
                    } else {
                        lib.showOptMenu(objOption)
                    }
                });
            }
        },
        bindBackEvent        : function() {
            // 回退时隐藏操作菜单
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {
                if (V.isModified()) {
                    lib.confirm('个人资料未保存，确定退出么？', function(idx) {
                        if (idx == 1) {
                            historyCallback();
                            gc.historyBack = historyCallback;
                        } else {
                            window.KalaGame && KalaGame.setIsBusy && KalaGame.setIsBusy(false);
                        }
                    });
                } else {
                    historyCallback();
                    gc.historyBack = historyCallback;
                }
            };
        },
        'bindSaveInfoEvent'  : function() {
            if (!window.KalaGame) {
                $('#btn_save').parent().show();
                $('#btn_save').on(gc.click, V.updateInfo);
            }
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        C.bindBackEvent();
        M.getAccountInfo();
        // postMessage回调
        gc.msgCallback = function(objResult) {
            lib.hideLoading();
            console.log("msgCallback response:" + JSON.stringify(objResult));
            if (objResult.result == 1) {
                // 设置头像为本地预览
                V.showPrevImg(objResult);
                // 发帖成功清除内容
                V.clearStored();
                lib.showTip('上传头像成功！');
            } else {
                if (objResult.ret == -6001) {
                    lib.showVcode(M.uploadAvatar);
                }
                // 失败，显示提示信息
                lib.showTip(objResult.msg);
            }
        };
    }

    exports.updateInfo = V.updateInfo;
});

