define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib'), com = require('user/js/common.js');
    exports.init = init;

    // 签名是否修改过
    var isModified = false;

    var M = {};

    var V = {};

    var C = {
        resetEvent : function() {
            // 增加保存的回调事件
            gc['editBtnCallback'] = function() {
                var objFormData = lib.getFormData($('#nickname'));
                if (!objFormData) {
                    return;
                }

                // 是否改变过昵称
                var strInfo = lib.getSessionItem('info');
                var objInfo = strInfo && JSON.parse(strInfo);

                if (objInfo.nickName != objFormData.nickName) {
                    isModified = true;

                    com.updateBaseInfo(function() {
                        var strInfo = lib.getSessionItem('info');
                        var objInfo = strInfo && JSON.parse(strInfo) || {};

                        // 缓存昵称
                        objInfo.nickName = objFormData.nickName;
                        lib.setSessionItem('info', JSON.stringify(objInfo));
                    }, {
                        formData : objFormData,
                        historyBack : true
                    });
                } else {
                    gc.historyBack();
                }
            };
        },
        initNickname : function() {
            if (!isModified) {
                var objInfo = lib.getSessionItem('info') && JSON.parse(lib.getSessionItem('info'));

                if (!objInfo) {
                    return;
                }

                $('#edit_name').val(objInfo.nickName);
            }
            isModified = false;
        },
        bindBackEvent : function() {
            // 重置回退事件
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {
                var strInfo = lib.getSessionItem('info');
                var objInfo = strInfo && JSON.parse(strInfo);
                var isModified = objInfo && !(objInfo.nickName == $.trim($('#edit_name').val()));

                if (isModified) {
                    lib.confirm("个人资料未保存，确定退出么？", function(nIndex) {
                        if (nIndex == 1) {
                            historyCallback();
                            gc.historyBack = historyCallback;
                        } else {
                            window.KalaGame && KalaGame.setIsBusy && KalaGame.setIsBusy(false);
                        }
                    });
                } else {
                    historyCallback();
                    gc.historyBack = historyCallback;
                }
            };
        }
    };

    function init() {
        C.resetEvent();
        C.initNickname();
        C.bindBackEvent();
    }

});
