define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib'), com = require('user/js/common.js');
    exports.init = init;

    // 个性签名最多可输入字符
    var nDefaultCount = 120;
    var isModified = false;

    var M = {};

    var V = {
        // js统计文本框输入的字符数
        countChar : function(n, strTextareaId, strSpanId) {
            var nCount = n - $.trim($('#' + strTextareaId).val()).length;
            $('#' + strSpanId).text(nCount);
            if (nCount < 0) {
                $('#' + strSpanId).addClass('W_error');
            } else {
                $('#' + strSpanId).removeClass('W_error');
            }
        }
    };

    var C = {
        init : function() {
            C.checkLeftChars();
        },
        resetEvent : function() {
            // 增加保存的回调事件
            gc['editBtnCallback'] = function() {
                var objFormData = lib.getFormData($('#sign'));

                if (!objFormData) {
                    return;
                }

                // 是否改变过签名
                var strInfo = lib.getSessionItem('info');
                var objInfo = strInfo && JSON.parse(strInfo);

                if (objInfo.sign != objFormData.sign) {
                    isModified = true;

                    com.updateBaseInfo(function() {
                        var strInfo = lib.getSessionItem('info');
                        var objInfo = strInfo && JSON.parse(strInfo) || {};

                        // 缓存签名
                        objInfo.sign = objFormData.sign;
                        lib.setSessionItem('info', JSON.stringify(objInfo));
                    }, {
                        formData : objFormData,
                        historyBack : true
                    });
                } else {
                    gc.historyBack();
                }
            };
        },
        initSign : function() {
            if (!isModified) {
                var strInfo = lib.getSessionItem('info');
                var objInfo = strInfo && JSON.parse(strInfo)

                $('#mySign').val(objInfo.sign);
                V.countChar(nDefaultCount, 'mySign', 'word_num');
            }
            isModified = false;
        },
        checkLeftChars : function() {
            // 检测还有多少字符可输入
            $('#mySign').on('keydown', function() {
                $('.num').show();
                V.countChar(nDefaultCount, 'mySign', 'word_num');
            }).on('keyup', function() {
                $(this).triggerHandler('keydown');
            });
        },
        bindBackEvent : function() {
            // 重置回退事件
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {
                var strInfo = lib.getSessionItem('info');
                var objInfo = strInfo && JSON.parse(strInfo);
                var isModified = objInfo && !(objInfo.sign == $.trim($('#mySign').val()));

                if (isModified) {
                    lib.confirm("个人资料未保存，确定退出么？", function(index) {
                        if (index == 1) {
                            historyCallback();
                            gc.historyBack = historyCallback;
                        } else {
                            window.KalaGame && KalaGame.setIsBusy && KalaGame.setIsBusy(false);
                        }
                    });
                } else {
                    historyCallback();
                    gc.historyBack = historyCallback;
                }
            };
        }
    };

    // 初始化执行一次
    C.init();

    function init() {
        C.resetEvent();
        C.initSign();
        C.bindBackEvent();
    }

});
