define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib'), md5 = require('md5');
    exports.init = init;

    var M = {
        updatePwd : function() {
            var data = {};
            var oldpw = $("#edit_oldPw").val();
            var newpw = $("#editPwNew").val();
            var confirmpw = $("#editPwConfirm").val();

            if (oldpw == '') {
                lib.showTip('请输入旧密码');
                lib.addFocus($('#edit_oldPw'));
                return;
            }
            if (V.checkPassword(newpw, true) == false) {
                lib.addFocus($('#editPwNew'))
                return;
            }
            if (V.checkPw(confirmpw, newpw) == false) {
                lib.addFocus($('#editPwConfirm'));
                return;
            }
            oldpw = md5.sha1(md5.sha1(oldpw));
            newpw = md5.sha1(md5.sha1(newpw));
            var req = {
                oldPwd : oldpw,
                newPwd : newpw
            };
            req['imgVcode'] = $('[name=vcodenum]').val();

            lib.postCross(lib.userUrl + "account/modifypwd", req, function(data) {
                if (data.result == 1) {
                    /*
                     lib.showTip("密码修改成功，请重新登录！");
                     lib.logout();
                     */
                    lib.showTip("密码修改成功!");
                    lib.historyBack();
                } else if (data.ret == -6001) {
                    //这里是要显示验证码的情况
                    lib.showVcode(M.updatePwd);
                } else {
                    lib.showTip(data.msg);
                }
            });
        }
    };

    var V = {
        checkPassword : function(password, strict) {
            if (password.length == 0 && strict != true) {
                return false;
            }
            if (password.length == 0) {
                lib.showTip('请输入登录密码!');
                return false;
            }
            if (password.length > 16 || password.length < 6) {
                lib.showTip('密码长度在6-16个字符之间!');
                return false;
            }
            for (var i = 0; i < password.length; i++) {
                var chr = password.charCodeAt(i);
                if (chr > 255) {
                    lib.showTip('密码格式错误!');
                    return false;
                } else if (chr == 32) {
                    lib.showTip('密码不能包含空格符!');
                    return false;
                }
            }
            return true;
        },
        // 检测两次输入密码是否一致
        checkPw : function(value1, value2) {// value1、value2分别是两次输入的密码
            if (value1 != value2) {
                lib.showTip("您输入的密码不一致");
                return false;
            }
            return true;
        },
        'clearPwdInputs' : function() {
            var strVcode = localStorage.getItem('imgVcode');

            if (!strVcode) {
                $('#edit_oldPw, #editPwNew, #editPwConfirm').val('');
            }
        }
    };

    var C = {
        init : function() {
            $("#edit_pw_complete").on(gc.click, function() {
                M.updatePwd();
            });
        }
    };

    // 初始化执行一次
    C.init();

    function init() {
        V.clearPwdInputs();
    }

})

