define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib'), md5 = require('md5'), com = require('userCom');
    exports.init = init;

    var M = {
        'visitorLogin' : function() {
            var url = lib.userUrl + "register/visitorLogin";
            var req = {};
            req.platformId = 1000;
            req.appId = lib.getParam("appId");
            req['timeout'] = 1209600;
            req['uuid'] = window.device && device.uuid;

            lib.postCross(url, req, function(data) {
                //随机码每次都要重新设置
                data.pwdRandom && localStorage.setItem('pwdRandom', data.pwdRandom);
                data.token && localStorage.setItem('token', data.token);
                data.uid && localStorage.setItem('uid', data.uid);
                data.openId && lib.setOpenAuthInfo(lib.appId, 'openId', data.openId);
                data.openToken && lib.setOpenAuthInfo(lib.appId, 'openToken', data.openToken);

                if (data.result == 1) {
                    var fromPage = lib.removeParam('fromPage');
                    var page = lib.getParam('page');

                    // 不存在openId，进入激活页面
                    if (lib.appId && lib.appId != 10000 && !data.openId) {
                        lib.redirect('user-activation');
                        return;
                    }

                    localStorage.setItem('isOldUser', 1);
                    // 清除注册时保留的密码
                    localStorage.removeItem('pwd');
                    localStorage.removeItem('oldPwd');

                    if (window.KalaGame && KalaGame.session) {
                        KalaGame.session(data.uid, data.token, data.openId, data.openToken);
                    } else {
                        fromPage = fromPage || 'user-info';
                        lib.redirect(fromPage, {
                            popState : true,
                            noClear : true
                        });

                        // 去除登录注册的特殊样式
                        lib.removeCustomizedStyle(lib.appId);
                    }
                } else {
                    if (data.ret == -6001) {
                        //这里是要显示验证码的情况
                        lib.showVcode(M.visitorLogin);
                    }

                    lib.showTip(data.msg);
                }
            });
        }
    };

    var C = {
        'init' : function() {
            var channel = lib.getParam("channel");
            // web版本没有访客模式
            if (window.device && device.uuid && channel != "client") {
                var $btnVisitorLogin = $('#btnVisitorLogin');
                $btnVisitorLogin.parent().removeClass('invisible');

                $btnVisitorLogin.on(gc.click, M.visitorLogin);
            }

            $("#version").text(lib.getParam("channel") + " " + lib.getVersionString());
            $("#version").click(function() {
                $(this).css('opacity', '100');
            });
            // 第三方登录
            com.toggleThirdpartyLogin();
        }
    };

    // 初始化执行一次
    C.init();

    function init() {
        //lib.loadCustomizedStyle();
        
        // 获取账号
        var account = localStorage.getItem('account');
        account && $('#account').val(account);

        //增加编辑的回调事件
        gc['editBtnCallback'] = function() {
            lib.redirect('game-faq_sub_login');
        };

        // 客户端显示简易注册
        /*
         if (window.KalaGame) {
         $('#btnquickreg').removeClass('invisible');
         }
         */
        /*
         $('input').on(gc.click, function(event) {
         console.log(event);
         });
         */
    }

});

