define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), lazyload = require('lazyload');
    exports.init = init;
    // 默认显示的游戏个数
    var defaultGameCount = 10 * lib.listCountMultiples();
    var M = {
        testCreateOrder : function() {
            //var url = "http://pay.api.kalagame.com/createOrder.php";
            var url = "http://user.api.kalagame.com/createOrder.php";
            var data = {
                'payItem'      : '100*1*10',
                'appId'        : lib.appId || 10001,
                'openId'       : lib.getOpenAuthInfo(lib.appId, 'openId') || 123,
                'openToken'    : lib.getOpenAuthInfo(lib.appId, 'openToken'),
                'ts'           : parseInt((new Date).getTime() / 1000),
                'goodsName'    : '小血瓶_test',
                'goodsUrl'     : 'http://kalacdn.kingsoft.com/m/user/images/normal_gg.jpg',
                'appParameter' : '{}'
            };
            lib.postCross(url, data, function(objResult) {
                if (!objResult.result) {
                    lib.showTip(objResult.msg);
                    return;
                }
                if (window.KalaGame && KalaGame.getPayView) {
                    KalaGame.getPayView(objResult.payUrl);
                } else {
                    var url = objResult.payUrl.split('#!')[1];
                    url = document.location.pathname + '#!' + url;
                    lib.dialog(url);
                }
            });
        },
        infoInit        : function() {
            lib.postCross(lib.userUrl + 'detail/getBaseInfo', function(getData) {
                if (getData.result == 1) {
                    V.showInfo(getData.data);
                } else {
                    // 失败，直接退回登录页面
                    lib.redirect("user-login");
                }
            }, {
                cache : true
            });
        },
        getMyGameList   : function(start) {
            var url = lib.gameUrl + 'app/getMyAppList';
            var params = {
                start : start || 0,
                count : defaultGameCount
            }
            lib.postCrossList(url, params, function(response) {
                if (response.result == 1) {
                    V.showMyGameList(response);
                } else {
                    // 失败，显示提示信息
                    lib.showTip(response.msg);
                }
            }, function() {
                M.getMyGameList(start);
            });
        },
        loadMore        : function() {
            var $gameList = $('#gameachivelist_wrap');
            var $spinner = $('#spinner_list');
            if ($gameList.attr('hasMore') != 'true') {
                $spinner.hide();
                return;
            }
            // 延迟显示
            var timeout = parseInt($spinner.attr('timeout'));
            lib.setTimeout(function() {
                var start = $gameList.find('li').length;
                M.getMyGameList(start);
            }, timeout);
        },
        formatDataList  : function(dataList) {
            for (var i = 0, len = dataList.length; i < len; i++) {
                var app = dataList[i];
                var myAchievementPoint = app.myAchievementPoint;
                var achievementPoint = app.achievementPoint;
                if (achievementPoint && achievementPoint == -1) {
                    // 添加noAchieve属性，标识是否有成就系统
                    app.noachieve = 'noachieve';
                } else {
                    app.noachieve = '';
                }
                if (myAchievementPoint && myAchievementPoint == -1) {
                    app.myAchievementPoint = '-';
                }
            }
            return dataList;
        }
    };
    var V = {
        showInfo       : function(data) {
            var $sex = $("#sex");
            if (data.sex == '1') {
                $sex.addClass('m');
            } else if (data.sex == '0') {
                $sex.removeAttr('class');
            }
            delete data.sex;
            // 设置默认头像
            var icon = data.icon;
            if (!icon) {
                data.icon = gc.defaultIcon_96;
            }
            // 设置总的游戏数
            $('#gameachivelist_wrap h4 span').text(data.appCount);
            lib.template(data, '#myinfo');
        },
        showMyGameList : function(response, pageInit) {
            // 显示缓存数据
            var $html = lib.showCacheList2(response, '#game_list_template', '#gameachivelist_wrap ul');
            // 绑定延迟加载图片事件
            $html && $html.find('img').lazyload();
        }
    };
    var C = {
        init : function() {
            // 绑定显示详细成就事件
            $('#gameachivelist_wrap').on(gc.tap, 'li', function() {
                var $this = $(this);
                // 如果没有成就系统，不绑定显示事件
                if ($this.find('p.noachieve').length) {
                    return;
                }
                lib.setParam('gameId', $(this).find('.gamename').attr('appId'));
                lib.redirect('achievement-myinfo');
            });
            $('#btn_purchase').on(gc.click, M.testCreateOrder);
            $('#btn_friend').on(gc.click, function() {
                lib.setParam('tab', 'friend-chat');
                lib.setParam('tabType', "friend");
                lib.redirect('common-tab');
            });
            // 加载我的游戏列表
            M.getMyGameList();
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        M.infoInit();
        //增加编辑的回调事件
        gc['editBtnCallback'] = function() {
            lib.redirect("user-edit_info");
        };
        //绑定滚动条事件
        lib.bindScrollEvent(M.loadMore, $('#gameachivelist_wrap ul'));
    }
});
