define(function(require, exports, module) {
	var $ = require('zepto'), lib = require('lib'), com = require('userCom'), md5 = require('js/md5.js');
	exports.init = init;

	var M = {
		login : function() {
			var platformId = 1001;
			var account = $('#account').val();
			var pwd = $('#pwd').val();

			var pattern = 4;
			// 第三方平台账号登陆
			var req = {
				account : account,
				pwd : md5.hex_md5(pwd),
				platformId : platformId,
				loginPattern : pattern,
				timeout : 86400
			};

			lib.appId && (req['appId'] = lib.appId);
			req['imgVcode'] = $('[name=vcodenum]').val();
			req['uuid'] = window.device && device.uuid;

			if ($("#ksrepassword").attr("checked")) {
				req['timeout'] = 31536000;
			}

			lib.postCross(lib.userUrl + 'account/login', req, function(data) {
				//随机码每次都要重新设置
				data.pwdRandom && localStorage.setItem('pwdRandom', data.pwdRandom);
				data.token && localStorage.setItem('token', data.token);
				data.uid && localStorage.setItem('uid', data.uid);
				data.openId && lib.setOpenAuthInfo(lib.appId, 'openId', data.openId);
				data.openToken && lib.setOpenAuthInfo(lib.appId, 'openToken', data.openToken);

				if (data.result == 1) {
					switch (data.status) {
						case 1:
							var fromPage = lib.removeParam('fromPage');
							var page = lib.getParam('page');

							if (lib.appId && lib.appId != 10000 && !data.openId) {
								lib.redirect('user-activation');
								return;
							}

							localStorage.setItem('isOldUser', 1);
							if (window.KalaGame) {
								KalaGame.session(data.uid, data.token, data.openId, data.openToken);
							} else {
								fromPage = fromPage || 'user-info';
								lib.redirect(fromPage, {
									popState : true,
									noClear : true
								});
							}
							break;
						case 2:
							lib.redirect('user-register');
							break;
						case 3:
							lib.showTip("未绑定手机或邮箱");
						case 4:
							lib.showTip("该手机已被注册");
						case 5:
							lib.showTip("该邮箱已被注册");
							lib.redirect('user-register');
							break;
					}
				} else {
					if (data.ret == -6001) {
						// 这里是要显示验证码的情况
						lib.showVcode(M.login);
					}

					lib.showTip(data.msg);
				}
			});
		}
	};

	var C = {
		init : function() {
			$('#btnksLogin').on(gc.click, this.loginClick);
		},
		loginClick : function() {
			var account = $('#account').val();
			var pwd = $('#pwd').val();
			if (account == '') {
				lib.showTip('请输入金山通行证');
				lib.addFocus('#account');
				return;
			} else if (pwd == '') {
				lib.showTip('请输入金山通行证密码');
				lib.addFocus('#pwd');
				return;
			} else {
				M.login();
			}
		}
	};

	// 初始化执行一次
	C.init();

	function init() {
	}

});
