define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib'), md5 = require('md5'), com = require('userCom');
    exports.init = init;
    var M = {
        'login'          : function() {
            if (!M.checkLoginArgs()) {
                return;
            }
            var req = M.getLoginArgs();
            localStorage.setItem('account', req.account);
            lib.postCross(lib.userUrl + 'account/login', req, function(data) {
                //随机码每次都要重新设置
                data.pwdRandom && localStorage.setItem('pwdRandom', data.pwdRandom);
                data.token && localStorage.setItem('token', data.token);
                data.uid && localStorage.setItem('uid', data.uid);
                data.openId && lib.setOpenAuthInfo(lib.appId, 'openId', data.openId);
                data.openToken && lib.setOpenAuthInfo(lib.appId, 'openToken', data.openToken);
                if (data.result == 1) {
                    var fromPage = lib.removeParam('fromPage');
                    var page = lib.getParam('page');
                    // 不存在openId，进入激活页面
                    if (lib.appId && lib.appId != 10000 && !data.openId) {
                        lib.redirect('user-activation');
                        return;
                    }
                    localStorage.setItem('isOldUser', 1);
                    // 清除注册时保留的密码
                    localStorage.removeItem('pwd');
                    localStorage.removeItem('oldPwd');
                    if (window.KalaGame && KalaGame.session) {
                        KalaGame.session(data.uid, data.token, data.openId, data.openToken);
                    } else {
                        fromPage = fromPage || 'user-info';
                        lib.redirect(fromPage, {
                            popState : true,
                            noClear  : true
                        });
                        // 去除登录注册的特殊样式
                        lib.removeCustomizedStyle(lib.appId);
                    }
                } else {
                    if (data.ret == -6001) {
                        //这里是要显示验证码的情况
                        lib.showVcode(M.login);
                    }
                    lib.showTip(data.msg);
                }
            });
        },
        'visitorLogin'   : function() {
            var url = lib.userUrl + "register/visitorLogin";
            var req = {};
            req.platformId = 1000;
            req.appId = lib.getParam("appId");
            req['timeout'] = 1209600;
            req['uuid'] = window.device && device.uuid;
            lib.postCross(url, req, function(data) {
                //随机码每次都要重新设置
                data.pwdRandom && localStorage.setItem('pwdRandom', data.pwdRandom);
                data.token && localStorage.setItem('token', data.token);
                data.uid && localStorage.setItem('uid', data.uid);
                data.openId && lib.setOpenAuthInfo(lib.appId, 'openId', data.openId);
                data.openToken && lib.setOpenAuthInfo(lib.appId, 'openToken', data.openToken);
                if (data.result == 1) {
                    var fromPage = lib.removeParam('fromPage');
                    var page = lib.getParam('page');
                    // 不存在openId，进入激活页面
                    if (lib.appId && lib.appId != 10000 && !data.openId) {
                        lib.redirect('user-activation');
                        return;
                    }
                    localStorage.setItem('isOldUser', 1);
                    // 清除注册时保留的密码
                    localStorage.removeItem('pwd');
                    localStorage.removeItem('oldPwd');
                    if (window.KalaGame && KalaGame.session) {
                        KalaGame.session(data.uid, data.token, data.openId, data.openToken);
                    } else {
                        fromPage = fromPage || 'user-info';
                        lib.redirect(fromPage, {
                            popState : true,
                            noClear  : true
                        });
                        // 去除登录注册的特殊样式
                        lib.removeCustomizedStyle(lib.appId);
                    }
                } else {
                    if (data.ret == -6001) {
                        //这里是要显示验证码的情况
                        lib.showVcode(M.visitorLogin);
                    }
                    lib.showTip(data.msg);
                }
            });
        },
        'checkLoginArgs' : function() {
            var $account = $('#account');
            var $pwd = $('#pwd');
            var pattern = checkGcAccount(true);
            if (!pattern) {
                lib.addFocus($account);
                return false;
            }
            if (!checkGcPassword(true)) {
                lib.addFocus($pwd);
                return false;
            }
            if (!localStorage.token) {
                lib.showTip('正在初始化中，请稍后再试.');
                lib.checkLogin();
                return false;
            }
            return true;
        },
        'getLoginArgs'   : function() {
            var $account = $('#account');
            var $pwd = $('#pwd');
            var platformId = 1000;
            var pattern = checkGcAccount(false);
            var pwdRandom = localStorage.getItem('pwdRandom');
            var pwd = $pwd.val();
            var req = {};
            if (lib.appId) {
                var openId = lib.getOpenAuthInfo(lib.appId, 'openId');
                var openToken = lib.getOpenAuthInfo(lib.appId, 'openToken');
                if (openId && openToken) {
                    req.openId = openId;
                    req.openToken = openToken;
                }
            }
            req.appId = lib.appId;
            req.account = $account.val();
            req.pwd = createPwd(pwd, pwdRandom);
            req.platformId = platformId;
            req.loginPattern = pattern;
            req['timeout'] = 1209600;
            req['uuid'] = window.device && device.uuid;
            // 绑定第三方账号
            req = com.addThirdpartyLoginParams(req, 'user-bindaccount');
            return req;
        }
    };
    var C = {
        'init' : function() {
            var channel = lib.getParam("channel");
            // web版本没有访客模式
            if (window.device && device.uuid && channel != "client") {
                var $btnVisitorLogin = $('#btnVisitorLogin');
                $btnVisitorLogin.parent().show();
                $btnVisitorLogin.on(gc.click, M.visitorLogin);
            }
            $('#btnLogin').unbind(gc.click).on(gc.click, M.login);
            localStorage.oldPwd && $('#comple_info_pwd').val(localStorage.oldPwd);
            $("#version").text(lib.getParam("channel") + " " + lib.getVersionString());
            $("#version").click(function() {
                $(this).css('opacity', '100');
            });
            $("#version").text(lib.getParam("channel") + " " + lib.getVersionString());
            $("#version").click(function() {
                $(this).css('opacity', '100');
            });
            // 第三方登录
            com.toggleThirdpartyLogin();
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        lib.flushInputBoxes();
        //lib.loadCustomizedStyle();
        // 获取账号
        var account = localStorage.getItem('account');
        account && $('#account').val(account);
        //增加编辑的回调事件
        gc['editBtnCallback'] = function() {
            lib.redirect('game-faq_sub_login');
        };
        // 客户端显示简易注册
        /*
         if (window.KalaGame) {
         $('#btnquickreg').removeClass('invisible');
         }
         */
        /*
         $('input').on(gc.click, function(event) {
         console.log(event);
         });
         */
    };
    function createPwd(pwd, random) {
        var stage1_hash = md5.sha1(pwd);
        var newPwd = md5.xor(md5.sha1(random + md5.sha1(stage1_hash)), stage1_hash);
        newPwd = md5.base64encode(newPwd);
        return newPwd;
    }

    /*
     * function getLoginPattern(account) { var email_pattern =
     * /^([a-z0-9_\.-]+)@([\da-z\.-]+)\.([a-z\.]{2,6})$/; var mobile_pattern =
     * /^1[3458]{1}[0-9]{9}$/; var kala_pattern = /^[1-9][0-9]{5,10}$/; if
     * (email_pattern.test(account)) { return 3; } else if
     * (mobile_pattern.test(account)) { return 2; } else if
     * (kala_pattern.test(account)){ return 1; } else{ return 0; } }
     */
    /**
     * 检察账号是否正确
     */
    function checkGcAccount(strict) {
        var o = $('#account');
        var account = $.trim(o.val());
        var loginPattern = false;
        if (/^[0-9]{11,}$/.test(account)) {
            if (!/^1\d{10}$/.test(account)) {
                lib.showTip('请输入正确的手机号!', o);
                // o.focus();
                return false;
            }
            loginPattern = 2;
        } else if (/^[0-9]+$/.test(account)) {
            if (!/^[1-9][0-9]{4,10}$/.test(account)) {
                lib.showTip('请输入正确的考拉号!', o);
                // o.focus();
                return false;
            }
            loginPattern = 1;
        } else if (/@/.test(account)) {
            if (!/^[a-zA-Z0-9_.]{1,30}@[a-zA-Z0-9-]{1,65}\.([a-zA-Z]{2,5}(\.[a-zA-Z]{2,3})?$)/.test(account)) {
                lib.showTip('请输入正确的邮箱!', o);
                // o.focus();
                return false;
            }
            loginPattern = 3;
        } else if (account.length > 0) {
            lib.showTip('请输入正确的登录账号!', o);
            // o.focus();
            return false;
        } else if (account.length == 0) {
            if (strict == true) {
                lib.showTip('请输入登录账号!', o);
                // o.focus();
            }
            return false;
        }
        // postData.account = account;
        return loginPattern;
    }

    function checkGcPassword(strict) {
        var o = $('#pwd');
        var password = o.val();
        if (password.length == 0 && strict != true) {
            return false;
        }
        if (password.length == 0) {
            lib.showTip('请输入登录密码!', o);
            // o.focus();
            return false;
        }
        if (password.length > 16 || password.length < 6) {
            lib.showTip('密码长度在6-16个字符之间!', o);
            return false;
        }
        for (var i = 0; i < password.length; i++) {
            var chr = password.charCodeAt(i);
            if (chr > 255) {
                lib.showTip('密码格式错误!', o);
                return false;
            } else if (chr == 32) {
                lib.showTip('密码不能包含空格符!', o);
                return false;
            }
        }
        // postData.pwd = password;
        return true;
    }
});

