define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), lazyload = require('lazyload'), com = require('user/js/common.js');
    exports.init = init;
    // 默认显示的游戏个数
    var defaultGameCount = 10 * lib.listCountMultiples();
    var M = {
        getUserId      : function() {
            var url = lib.userUrl + 'detail/getBaseInfo';
            lib.postCross(url, function(response) {
                if (response.result == 1) {
                    var userId = response.data.userId;
                    if (lib.getParam("userId") != userId) {
                        lib.setTitle("Ta的主题");
                    } else {
                        lib.setTitle("我的主题");
                    }
                }
            }, {
                cache     : "must",
                noLoading : true
            });
        },
        formatDataList : function(dataList) {
            if (!dataList) {
                return;
            }
            var list = [];
            var llen = dataList.length;
            if (!llen) {
                list.push({
                    icon : gc.defaultIcon_96
                });
            } else {
                for (var i = 0; i < llen; i++) {
                    list.push({
                        icon : dataList[i]
                    });
                }
            }
            return list;
        }
    };
    var V = {
        showUserInfo : function(data) {
            var dataList = M.formatDataList(data.icons);
            if (!dataList) {
                return;
            }
            var $html = $(lib.template2(dataList, '#avatar_template'));
            $('#avatar p').html($html);
            $html && $html.find('img').lazyload();
            lib.setTitle(data.nickName);
            if (!data.sign) {
                data.sign = com.defaultSign;
            }
            lib.template(data, '#sign');
            // 超过4行显示更多
            // if ($('pre').height() > $('#signinfo').height()) {
            // $('span.more').show();
            // }
        }
    };
    var C = {
        init                  : function() {
        },
        bindBackEvent         : function() {
            // 回退时去除性别样式
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {
                $('#page_title').removeClass('sex m f');
                lib.historyBack();
                gc.historyBack = historyCallback;
            };
        },
        bindShowOptMenuEvent  : function() {
            $('#avatar').on(gc.click, 'img', function() {
                avatarIndex = $('#avatar img').index($(this));
                lib.showOriginalImg('#avatar', avatarIndex);
            });
        },
        bindShowMoreSignEvent : function() {
            $('span.more').on(gc.click, function() {
                $('#signinfo').css('max-height', '');
                $(this).hide();
                return false;
            });
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        M.getUserId();
    }
});
