define(function(require, exports, module) {
	var $ = require('zepto'), lib = require('lib');
	exports.init = init;

	var timeout = 2000, sendTimer;
	//倒计时30秒可重新发短信
	var remainTime, interval = 0, timeoutHandler = 0;
	var receiver, telNum;
	
	gc.sendSms = function(result) {
	    //有响应了，不需要3秒超时响应了
	    timeoutHandler && clearTimeout(timeoutHandler);
		if (!result.result) {
		    remainTime = 30;
		    //发送失败，不需要倒计时了
		    interval && clearInterval(interval);
			lib.showTip(result.msg);
			//这里知道失败了
			V.updateSendBtn(false);
		} else {
            // 发送短信后，三秒后才开始检查
            lib.setTimeout(M.checkSMSStatus, 3000);
            // 30秒后检查短信状态间隔变为5秒
            lib.setTimeout(function() {
                timeout = 5000;
            }, 30000);
            
		    //发送成功了，发给后台一个提示
		    var url = lib.userUrl + "account/sendSms";
		    var data = {channel:receiver};
		    lib.postCross(url, data, function(){}, {
                "noLoading" : true
            });
		}
	};
	
	gc.getTelNum = function(num) {
		telNum = num;
	};

	var M = {
		sendSMS : function() {
		    var $this = $(this);
			var className = $this.attr('class');
			//判断按钮是否灰色
			if (className.indexOf('ontimer') == -1) {
				V.updateSendBtn(true);
				receiver = '10690999123888';
				var message = 'kalagame#register#' + localStorage.getItem('token');
				if (window.KalaGame && KalaGame.sendSms) {
					KalaGame.sendSms(receiver, message);
				}
			    
	            //开始定时
	            interval && clearInterval(interval);
	            interval = lib.setInterval(function() {
	                if (remainTime--) {
	                    V.updateSendBtn(true);
	                } else {
	                    remainTime = 30;
	                    clearInterval(interval);
	                    interval = 0;
	                    $('#submit').html('重新发送短信').removeClass('ontimer');
	                }
	            }, 1000);
	            
			}
		},
		checkSMSStatus : function() {
		    console.log('checkSMSStatus');
			var url = lib.userUrl + 'account/checkSmsStatus';
			lib.postCross(url, function(response) {
				if (response.result == 1) {
					var valid = response.valid;
					if (valid) {
						//知道结果了，重置按钮样式
						V.updateSendBtn(false);
						localStorage.setItem('account', response.account);

						if (valid == 1) {
							// 完善资料
							lib.redirect('user-complete_info_q');
						} else if (valid == 2) {
							lib.showTip('账号已存在，请直接登录！');
							lib.redirect('user-login');
						}
					} else {
					    sendTimer && clearTimeout(sendTimer);
						sendTimer = lib.setTimeout(M.checkSMSStatus, timeout);
					}
				} else {
					lib.showTip(response.msg);
				}
			}, {
				"noLoading" : true
			});
		}
	};

	var V = {
		updateSendBtn : function(isRunning) {
			//console.log("V.updateSendBtn:" + isRunning);
			var $submit = $('#submit');
			if (isRunning) {
				$submit.html('短信发送中...(<span id="remainTime">' + remainTime + '</span>)');
				$submit.addClass('ontimer');
			} else {
				$submit.html('发送短信注册');
				$submit.removeClass('ontimer');
			}
		},
		initLoadingHtml : function() {
		    var loadingHtml = '\
    		   <div id="quickly-loading" class="loading" style="display:table!important;">\
                    <div class="pageprogress">\
                    <dl class="sending">\
                        <dt>\
                            正在注册\
                            <span>不同的网络情况，注册可能需要花费一些时间，请耐心等待 :)</span>\
                        </dt>\
                        <dd><span style="width:50%;"></span></dd>\
                    </dl>\
                </div>\
             </div>';
		    
		    if (!$('#quickly-loading').length) {
		        $('body').append(loadingHtml);
		    }
		}
	};

	var C = {
		init : function() {
			$('#submit').on(gc.click, M.sendSMS);
			window.KalaGame && KalaGame.getTelNum && KalaGame.getTelNum();
		}
	};

	// 初始化执行一次
	C.init();

	function init() {
	    remainTime = 30;
		V.updateSendBtn(false);
	}

});
