define(function(require, exports, module) {
	var $ = require('zepto'), lib = require('lib'), md5 = require('md5');
	exports.init = init;

	// 默认平台ID
	var platformId = 1000;

	var M = {
		doResetPwd : function() {
			var pwd = $('#reset_new').val();
			var newPwd = md5.sha1(md5.sha1(pwd));

			lib.postCross(lib.userUrl + 'account/doResetPwd', {
				platformId : platformId,
				newPwd : newPwd
			}, function(data) {
				if (data.result == 1) {
					lib.showTip("重置成功");
					lib.logout();
				} else {
					lib.showTip(data.msg);
				}
			})
		}
	};

	var V = {
		reset_passwordInit : function() {
			$('#resetNickName').html(gc.resetNickName);
			V.hiddenBtn('back');
		},
		hiddenBtn : function(btn) {
			$("[data-role='" + btn + "']").addClass("hidden");
		},
		checkPassword : function(password, strict) {
			if (password.length == 0) {
				lib.showTip('请输入密码!');
				return false;
			}
			if (password.length > 16 || password.length < 6) {
				lib.showTip('密码长度在6-16个字符之间!');
				return false;
			}
			for (var i = 0; i < password.length; i++) {
				var chr = password.charCodeAt(i);
				if (chr > 255) {
					lib.showTip('密码格式错误!');
					return false;
				} else if (chr == 32) {
					lib.showTip('密码不能包含空格符!');
					return false;
				}
			}
			return true;
		},
		// 检测两次输入密码是否一致
		checkPw : function(value1, value2) {// value1、value2分别是两次输
			if (value1 != value2) {
				lib.showTip('您输入的密码不一致');
				return false;
			} else {
				return true;
			}
		},
		comfirePwd : function() {
			var value1 = $('#reset_confirm').val();
			var value2 = $('#reset_new').val();
			if (!V.checkPassword(value2)) {
				lib.addFocus($('#reset_new'));
				return false;
			}
			if (!V.checkPassword(value1)) {
				lib.addFocus($('#reset_confirm'));
				return false;
			}
			if (V.checkPw(value1, value2) == false) {
				lib.addFocus($('#reset_confirm'));
				return false;
			}
			return true;
		}
	};

	var C = {
		init : function() {
			$('#resetPwdSubmit').on(gc.click, function() {
				C.resetPwdSubmit();
			});

		},
		resetPwdSubmit : function() {
			if (!V.comfirePwd()) {
				return false;
			}
			M.doResetPwd();
		}
	};

	// 初始化执行一次
	C.init();

	function init() {
		lib.loadCustomizedStyle();
		V.reset_passwordInit();
	}

});
