define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib'), com = require('userCom');
    exports.init = init;

    // 默认平台ID
    var platformId = 1000;

    var M = {
        checkAccount : function() {
            var account = $('#account').val();
            localStorage.setItem('account', account);

            if (account == '') {
                lib.showTip('请输入账号');
                lib.addFocus($('#account'));
                return false;
            } else {
                gc.pattern = com.getPattern(platformId, account);
                if (!gc.pattern) {
                    lib.showTip('手机/邮箱格式错误');
                    lib.addFocus($("#account"));
                    return false;
                }
            }

            lib.postCross(lib.userUrl + 'account/resetPwd', {
                account : account,
                platformId : platformId,
                regPattern : gc.pattern,
                imgVcode : $('[name=vcodenum]').val()
            }, function(data) {
                if (data.result == 1) {
                    M.sendResetPwdCode();
                } else if (data.ret == -6001) {
                    // 这里是要显示验证码的情况
                    lib.showVcode(M.checkAccount);
                } else if (data.ret != '-3007') {
                    lib.showTip(data.msg);
                }
            });
        },
        sendResetPwdCode : function() {
            var strUrl = lib.userUrl + 'account/sendResetPwdCode';
            var objData = {
                platformId : platformId,
                isInit : 1,
                imgVcode : $('[name=vcodenum]').val()
            }

            lib.postCross(strUrl, objData, function(objResult) {
                lib.setSessionItem('resetCodeResponse', JSON.stringify(objResult));
                lib.redirect('user-check_reset');
            });
        }
    };

    var C = {
        init : function() {
            // 绑定提交事件
            $('#submit').on(gc.click, M.checkAccount);
        }
    };

    // 初始化执行一次
    C.init();

    function init() {
        lib.loadCustomizedStyle();
        gc.pattern = 2;
    }

});
