define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib');
    exports.init = init;
    var M = {
        infoInit     : function() {
            lib.postCross(lib.userUrl + 'detail/getAccountInfo', function(getData) {
                if (getData.result == 1) {
                    V.showInfo(getData.data);
                } else {
                    //失败，直接退回登录页面
                    lib.redirect("user-login");
                }
            }, {
                'cache' : true
            });
        },
        getLeftKCoin : function() {
            var url = lib.payUrl + "order/getLeftKCoin";
            lib.postCross(url, function(objResult) {
                if (objResult.result) {
                    $('#leftKCoin').text(objResult.leftKCoin);
                } else {
                    lib.showTip(objResult.msg);
                }
            }, {
                'noLoading' : true
            });
        },
        logout       : function() {
            lib.confirm("确定要退出登录吗？", function(index) {
                if (index != 1) {
                    return;
                }
                var appId = lib.getParam('appId');
                var openId = lib.getOpenAuthInfo(appId, 'openId');
                var openToken = lib.getOpenAuthInfo(appId, 'openToken');
                var data = {};
                data['appId'] = appId;
                if (openId && openToken) {
                    data['openId'] = openId;
                    data['openToken'] = openToken;
                }
                var url = lib.userUrl + 'account/logout';
                lib.postCross(url, data, function(objResult) {
                    if (objResult.result) {
                        lib.logout();
                    } else {
                        lib.showTip(objResult.msg);
                    }
                });
            });
        }
    };
    var C = {
        init                   : function() {
            C.bindCheckUpdateEvent();
            $('#btn_logout').on("click", M.logout);
            //网页版和客户端版需要显示配置项
            if (!window.KalaGame || window.KalaGameClient) {
                $('.settinglist').show();
                $('#btn_logout').show();
            }
            $('#btn_recharge').on(gc.click, function() {
                if (lib.getParam("channel") == "xiaomi") {
                    lib.redirect("pay-mi_charge_combo");
                } else if (lib.getParam("channel") == "apple") {
                    lib.redirect("pay-ios_charge_combo");
                } else {
                    lib.redirect("pay-recharge");
                }
            });
        },
        'bindCheckUpdateEvent' : function() {
            var $checkUpdate = $('#checkUpdate');
            if (window.KalaGameClient && KalaGameClient.checkUpdate) {
                $checkUpdate.removeClass('invisible');
                $checkUpdate.on(gc.click, function() {
                    if (KalaGameClient.checkUpdate) {
                        KalaGameClient.checkUpdate();
                    } else {
                        lib.showTip('Web版本无需升级！');
                    }
                });
            } else {
                $checkUpdate.remove();
            }
        }
    };
    var V = {
        showInfo : function(data) {
            if (!data.icon) {
                data.icon = gc.defaultIcon_96;
            }
            lib.template(data, '#pay_myinfo');
        }
    };

    function init() {
        $('#leftKCoin').text("加载中...");
        M.getLeftKCoin();
        M.infoInit();
    }

    C.init();
});

