define(function(require, exports, module) {
    var $ = require('jquery'), lib = require('lib'), lazyload = require('lazyload'), com = require('user/js/common.js');
    exports.init = init;
    var M = {
        getAccountInfo : function() {
            lib.postCross(lib.userUrl + 'detail/getAccountInfo', function(response) {
                if (response.result == 1) {
                    V.showAccountInfo(response);
                } else {
                    //失败，直接退回登录页面
                    lib.redirect("user-login");
                }
            });
            return false;
        },
        getIcons       : function() {
            var url = lib.userUrl + 'detail/getIcons';
            lib.postCross(url, function(response) {
                if (response.result == 1) {
                    V.showIcons(response);
                } else {
                    lib.showTip(response.msg);
                }
            });
        },
        formatDataList : function(dataList) {
            if (!dataList) {
                return;
            }
            var list = [];
            var llen = dataList.length;
            if (!llen) {
                list.push({
                    icon : gc.defaultIcon_96
                });
            } else {
                for (var i = 0; i < llen; i++) {
                    list.push({
                        icon : dataList[i]
                    });
                }
            }
            return list;
        }
    };
    var V = {
        cacheInfo       : function() {
            var info = lib.getSessionItem('info') && JSON.parse(lib.getSessionItem('info')) || {};
            info.sign = $('[name="sign"]').text();
            lib.setSessionItem('info', JSON.stringify(info));
        },
        showAccountInfo : function(response) {
            var data = response.data;
            $('[name="sign"]').text((data.sign || com.defaultSign));
            // 超过4行显示更多
            if ($('pre').height() > $('#signinfo').height()) {
                $('span.more').show();
            }
        },
        showIcons       : function(response) {
            var dataList = M.formatDataList(response.data);
            if (!dataList) {
                return;
            }
            var $html = $(lib.template2(dataList, '#avatar_template'));
            $('#avatar p').html($html);
            $html && $html.find('img').lazyload();
        }
    };
    var C = {
        init                  : function() {
            $('#sign').on(gc.click, V.cacheInfo);
            C.bindShowOptMenuEvent();
            C.bindShowMoreSignEvent();
        },
        bindShowOptMenuEvent  : function() {
            $('#avatar').on(gc.click, 'img', function() {
                avatarIndex = $('#avatar img').index($(this));
                lib.showOriginalImg('#avatar', avatarIndex);
            });
        },
        bindShowMoreSignEvent : function() {
            $('span.more').on(gc.click, function() {
                $('#signinfo').css('max-height', '');
                $(this).hide();
                return false;
            });
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        // 默认隐藏更多
        $('span.more').hide();
        $('#signinfo').css('max-height', '144px');
        M.getAccountInfo();
        M.getIcons();
        //增加编辑的回调事件
        gc['editBtnCallback'] = function() {
            lib.redirect("user-edit_info");
        };
    }
});

