define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), lazyload = require('lazyload'), com = require('gameComm');
    exports.init = init;

    var M = {
        formatData : function(data, strServerTime) {
            if (!data) {
                return;
            }

            // 设置头像
            var icon = data.icon;
            data.icon = icon ? icon : gc.defaultIcon_96;
            var createTime = data.createTime;
            if (createTime) {
                data.postTime = lib.dateDiff(strServerTime, data.createTime);
            } else {
                data.postTime = '加载中...';
            }

            // 解析表情
            var postCount = data.content;
            var pattern = /\[[\u4e00-\u9fa5]+\]/ig;

            if (postCount) {
                data.content = postCount.replace(pattern, com.parseEmotionPath);
            }

            // 解析图片
            var attach = data.attach;
            if (attach) {
                var html = com.parseUploadedImages(postCount, attach);
                data.content += html;
            }

            return data;
        },
        parseEmotionPath : function(emotion) {
            var emotions = com.emotions;

            var result = emotions.filter(function(em) {
                return (emotion == '[' + em['name'] + ']') || (emotion == '[' + em['name_old'] + ']');
            });

            if (result.length) {
                emotion = '<img src="' + result[0].icon + '" />';
            }

            return emotion;
        }
    };

    var V = {
        showPostDetail : function() {
            var strMsgInfo = lib.getSessionItem('msgInfo');
            var objMsgInfo = strMsgInfo && JSON.parse(strMsgInfo);
            $('#spinner_list').hide();
            if (!objMsgInfo) {
                lib.showTip('暂无数据');
                return;
            }
            var objData = M.formatData(objMsgInfo.data, objMsgInfo.serverTime);
            lib.template(objData, '#msg_content');
            var $html = $('#msg_content');
            $html.removeClass('invisible');

            // 设置回复中图片的尺寸
            lib.setImgSize($html.find('p.comment'));

            // 图片渐显
            $('#msg_content img[data-original]').lazyload();

            // 清除缓存数据
            lib.removeSessionItem('msgInfo');
        }
    };

    var C = {
        init : function() {
        }
    }

    // 初始化一次
    C.init();

    function init() {
        V.showPostDetail();
    }

});
