define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), lazyload = require('lazyload'), com = require('user/js/common.js');
    exports.init = init;
    var M = {
        getUserInfo    : function() {
            var url = lib.userUrl + 'friend/showInfo';
            var params = {
                friendId : lib.getParam('userId')
            };
            // 清空图片
            $('#avatar p').html('');
            lib.postCross(url, params, function(response) {
                if (response.result == 1) {
                    V.showUserInfo(response.data);
                } else {
                    lib.showTip(response.msg);
                    //lib.redirect("user-login");
                }
            }, {
                cache : true
            });
        },
        formatDataList : function(dataList) {
            if (!dataList) {
                return;
            }
            var list = [];
            var llen = dataList.length;
            if (!llen) {
                list.push({
                    icon : gc.defaultIcon_96
                });
            } else {
                for (var i = 0; i < llen; i++) {
                    list.push({
                        icon : dataList[i]
                    });
                }
            }
            return list;
        }
    };
    var V = {
        showUserInfo : function(data) {
            var dataList = M.formatDataList(data.icons);
            if (!dataList) {
                return;
            }
            var $html = $(lib.template2(dataList, '#avatar_template'));
            $('#avatar p').html($html);
            $html && $html.find('img').lazyload();
            lib.setTitle(data.nickName);
            if (!data.sign) {
                data.sign = com.defaultSign;
            }
            lib.template(data, '#sign');
            // 超过4行显示更多
            // if ($('pre').height() > $('#signinfo').height()) {
            // $('span.more').show();
            // }
        }
    };
    var C = {
        init                  : function() {
            C.bindShowOptMenuEvent();
            // C.bindShowMoreSignEvent();
        },
        bindBackEvent         : function() {
            // 回退时去除性别样式
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {
                $('#page_title').removeClass('sex m f');
                lib.historyBack();
                gc.historyBack = historyCallback;
            };
        },
        bindShowOptMenuEvent  : function() {
            $('#avatar').on(gc.click, 'img', function() {
                avatarIndex = $('#avatar img').index($(this));
                lib.showOriginalImg('#avatar', avatarIndex);
            });
        },
        bindShowMoreSignEvent : function() {
            $('span.more').on(gc.click, function() {
                $('#signinfo').css('max-height', '');
                $(this).hide();
                return false;
            });
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        // 默认隐藏更多
        // $('span.more').hide();
        // $('#signinfo').css('max-height', '144px');
        M.getUserInfo();
        C.bindBackEvent();
    }
});
